------------------------------------------------------------------
------------------------------------------------------------------
-- Author: Losso
-- Date:   17/07/2003
-- Notes:  Aggiunta la tabella LayoutImages. Viene popolata con i dati 
--         presenti nel Template, assumendo che il Template sia relativo
--         alla versione 01.00.03
--
--         Modificata la tabella DeviceStatus con aggiunta della colonna
--         CountryCode. I dati vengono cancellati per essere ricopiati dal Template
--
--
--
------------------------------------------------------------------
------------------------------------------------------------------


BEGIN TRANSACTION

-- place customom SQL And DDL for upgrade here


-------------------------------- CONFIG DB ---------------------------
----------------------------------------------------------------------
USE _ConfigDB_x


-- LayoutImages
--
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[LayoutImages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[LayoutImages]
GO

CREATE TABLE [dbo].[LayoutImages] (
	[ID_Image] [int] NOT NULL ,
	[ImageStatus] [smallint] NOT NULL ,
	[ImageBmp] [image] NOT NULL ,
	[ImageName] [varchar] (100) NOT NULL ,
	[rowguid] [uniqueidentifier] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

INSERT INTO LayoutImages (ID_Image,ImageStatus,ImageBmp,ImageName)
SELECT ID_Image,ImageStatus,ImageBmp,ImageName FROM _TemplateConfigDB_x.dbo.LayoutImages
GO

-- Update trigger  & stored procedure for DB performance improoving

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: stored procedure dbo.UpdateVI    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UpdateVI]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[UpdateVI]
GO

CREATE       PROCEDURE [UpdateVI] 
		
		@ID_VI as int   
		
		AS
		
		declare @CurrentStandByState as int
		declare @NewStandByState as int
		declare @find as int 		
		declare @Sdf  as smallint
		declare @Neutral as int
		set @find = 2 --neutral status
		set @Neutral = 1

--print 'START: stProc UpdateVI, ID=' + convert(varchar,@ID_VI)

		select @CurrentStandByState=  StandByFlag from virtualinstruments where ID_VirtualInstrument=@ID_VI

		select @NewStandByState=  max(StandByFlag) from VirtualResources VR where VR.Ref_IDVirtualInstr = @ID_VI

		set @NewStandByState=isnull(@NewStandByState,2)


		if @CurrentStandByState<>@NewStandByState
			BEGIN
-- print 'UPDT: stProc UpdateVI, ID=' + convert(varchar,@ID_VI)	
				update VirtualInstruments set InternalUpdate = 0 where ID_VirtualInstrument = @ID_VI
				update VirtualInstruments set InternalUpdate = 1 where ID_VirtualInstrument = @ID_VI
				update VirtualInstruments set StandByFlag = @NewStandByState where ID_VirtualInstrument = @ID_VI
			END

-- print 'END: stProc UpdateVI, ID=' + convert(varchar,@ID_VI)



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: stored procedure dbo.UpdateVR    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UpdateVR]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[UpdateVR]
GO


CREATE   PROCEDURE [UpdateVR] 

@ID_VR as int   

AS

declare  @sbfSum as int 
declare @CurrentStandByState as int
declare @NewStandByState as int

-- NB: A seguito analisi 27/6/2003 con Losso, se una risorsa  in StByFlag=2, tale stato
-- non deve essere modificato da un trigger, ma risolto manualmente attraverso 
-- i tools di configurazione della Suite.

select @CurrentStandByState=  standbyflag from virtualresources where ID_VirtualResource=@ID_VR
if isnull(@CurrentStandByState,2)=2 
	BEGIN
		Return
	END

set @NewStandByState = 2 
select @sbfSum = sum(PR.Standbyflag) 
		from VirtualPhysResourceTable VPRT 
		inner join  PhysResources PR on 
			VPRT.ID_PhysResource = PR.ID_PhysResource 
		where VPRT.ID_VirtualResource = @ID_VR

	if isnull(@sbfSum,-1) = 0 set @NewStandByState = 0 --no  inactive PRs
	ELSE if isnull(@sbfSum,-1) > 0 set @NewStandByState = 1 --at least one inactive PR
	ELSE if isnull(@sbfSum,-1) < 0 set @NewStandByState = 2 --no PR at all
--	 print convert(char(20), @NewStandByState) +'*********************'
	


	if @NewStandByState<>@CurrentStandByState --Aggiorno solo se il valore  cambiato
		BEGIN

			--set the internalUpdate to allow the update without the update trigger to fire error message
			update VirtualResources set InternalUpdate = 1 where ID_VirtualResource = @ID_VR
			update VirtualResources set StandByFlag = @NewStandByState where ID_VirtualResource = @ID_VR
			update VirtualResources set InternalUpdate = 0 where ID_VirtualResource = @ID_VR
		END


/*	if @NewStandByState = 0
		--all the StandByFlag are 0 / PR's
		update VirtualResources set StandByFlag = 0 where ID_VirtualResource = @ID_VR
	if @NewStandByState = 1
		--at least one StandByFlag is 1
		update VirtualResources set StandByFlag = 1 where ID_VirtualResource = @ID_VR
	if @NewStandByState = 2
		--the VR has no PRs so put in a neutral status
		update VirtualResources set StandByFlag = 2 where ID_VirtualResource = @ID_VR
	--set the internalUpdate to neutral status
	update VirtualResources set InternalUpdate = 0 where ID_VirtualResource = @ID_VR

*/


GO


GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: stored procedure dbo.UpdateVR    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UpdateVR]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[UpdateVR]
GO

CREATE   PROCEDURE [UpdateVR] 

@ID_VR as int   

AS

declare  @sbfSum as int 
declare @CurrentStandByState as int
declare @NewStandByState as int

-- NB: A seguito analisi 27/6/2003 con Losso, se una risorsa  in StByFlag=2, tale stato
-- non deve essere modificato da un trigger, ma risolto manualmente attraverso 
-- i tools di configurazione della Suite.

select @CurrentStandByState=  standbyflag from virtualresources where ID_VirtualResource=@ID_VR
if isnull(@CurrentStandByState,2)=2 
	BEGIN
		Return
	END

set @NewStandByState = 2 
select @sbfSum = sum(PR.Standbyflag) 
		from VirtualPhysResourceTable VPRT 
		inner join  PhysResources PR on 
			VPRT.ID_PhysResource = PR.ID_PhysResource 
		where VPRT.ID_VirtualResource = @ID_VR

	if isnull(@sbfSum,-1) = 0 set @NewStandByState = 0 --no  inactive PRs
	ELSE if isnull(@sbfSum,-1) > 0 set @NewStandByState = 1 --at least one inactive PR
	ELSE if isnull(@sbfSum,-1) < 0 set @NewStandByState = 2 --no PR at all
--	 print convert(char(20), @NewStandByState) +'*********************'
	


	if @NewStandByState<>@CurrentStandByState --Aggiorno solo se il valore  cambiato
		BEGIN

			--set the internalUpdate to allow the update without the update trigger to fire error message
			update VirtualResources set InternalUpdate = 1 where ID_VirtualResource = @ID_VR
			update VirtualResources set StandByFlag = @NewStandByState where ID_VirtualResource = @ID_VR
			update VirtualResources set InternalUpdate = 0 where ID_VirtualResource = @ID_VR
		END


/*	if @NewStandByState = 0
		--all the StandByFlag are 0 / PR's
		update VirtualResources set StandByFlag = 0 where ID_VirtualResource = @ID_VR
	if @NewStandByState = 1
		--at least one StandByFlag is 1
		update VirtualResources set StandByFlag = 1 where ID_VirtualResource = @ID_VR
	if @NewStandByState = 2
		--the VR has no PRs so put in a neutral status
		update VirtualResources set StandByFlag = 2 where ID_VirtualResource = @ID_VR
	--set the internalUpdate to neutral status
	update VirtualResources set InternalUpdate = 0 where ID_VirtualResource = @ID_VR

*/





GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.Networksdelete    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Networksdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[Networksdelete]
GO




CREATE   Trigger Networksdelete on dbo.Networks 
for delete 
as
BEGIN

if @@ROWCOUNT=0 
BEGIN
	RETURN
END


declare @errorNumber as int
declare @errorMsg as varchar(250)

print ' trigger Networksdelete' 
-- Modifica 27/6/2003 F. De Conti
-- Butto via il cursore e uso una select su deleted per copiare le entries nello storico
	insert Hist_Networks 
		(ID_Network, 
		InterfacePort, 
		Name, 
		Description, 
		Notes, 
		DeviceType, 
		ValidateStartDate, 
		ValidateEndDate)
		(select ID_Network, 
				InterfacePort, 
				Name, 
				Description, 
				Notes, 
				DeviceType, 
				ValidateStartDate,
				Getdate() from deleted)


/*
--copy in History table
declare @ID as int
declare @InPort as varchar(50)
declare @Name as varchar(50)
declare @Desc as varchar(50)
declare @Notes as varchar(255)
declare @DevType as varchar(50)
declare @Start as datetime
declare @Last as datetime
print ' trigger Networksdelete' 
declare  CrsNetwork cursor for select ID_Network, InterfacePort, Name, Description, Notes, DeviceType, ValidateStartDate from deleted
open CrsNetwork
fetch next from CrsNetwork into @ID ,@InPort ,@Name ,@Desc ,@Notes ,@DevType ,@Start

WHILE @@FETCH_STATUS = 0
	begin	
	insert Hist_Networks (ID_Network, InterfacePort, Name, Description, Notes, DeviceType, ValidateStartDate, ValidateEndDate)
		values(@ID ,@InPort ,@Name ,@Desc ,@Notes ,@DevType ,@Start ,GETDATE())
	fetch next from CrsNetwork into @ID ,@InPort ,@Name ,@Desc ,@Notes ,@DevType ,@Start
	end
CLOSE CrsNetwork
DEALLOCATE CrsNetwork
*/


--delete from PhysInstruments
-- Butto via la '..where ..in select...' e uso una join su deleted
/*
delete PhysInstruments where Ref_IDNet in (select ID_Network from deleted)
*/
	delete PhI
	from PhysInstruments PhI inner join deleted D on
		PhI.Ref_IDNet=D.ID_Network


if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution on Networks table.'
    goto errorHandler
 end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END




GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.NetworksInsert    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[NetworksInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[NetworksInsert]
GO




CREATE   TRIGGER [NetworksInsert] ON dbo.Networks 
FOR INSERT
AS
Begin

declare @errorNumber as int
declare @errorMsg as varchar(250)



print ' trigger NetworksInsert' 

--test if the StabdByFlag field has the values strictly 1 or 0  
declare @Rows as int
set @Rows = 0
-- De Conti 08/07/2003 select @Rows = count(ID_Network) from inserted 
select @Rows = count(*) from inserted 
		where standbyflag <> 0 and standbyflag <> 1
if @Rows <> 0
begin 
    select @errorNumber = 30006,
             @errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    goto errorHandler
end

--set the internalUpdate to allow the update without the update trigger to fire error message
-- update networks set InternalUpdate = 1 
-- 	where id_network in (select id_network from inserted)
update n
set 
	InternalUpdate = 1
from networks n
	inner join inserted i on
	n.id_network=i.id_network

--set the start date
-- De Conti, 08/07/2003
-- Commentato il seguente blocco, per effettuare l'update  con 
-- un join anzich select in..
-- NB:l'update di LastModifiedDate viene effettuato dal trigger di update, quindi  superfluo
-- inserirlo qui
/*
update networks set validatestartdate = getdate() 
	where id_network in (select id_network from inserted)
--set LastModifiedDate 
update Networks set LastModifiedDate = GetDATE() 
	where id_network in (select id_network from inserted)
*/
-- Nuovo codice:

update n
set 
	validatestartdate = GetDate()
from networks n
	inner join inserted i on
	n.id_network=i.id_network
	


--set the internalUpdate to neutral status
-- update networks set InternalUpdate = 0
--	where id_network in (select id_network from inserted)

update n
set 
	InternalUpdate = 0
from networks n
	inner join inserted i on
	n.id_network=i.id_network

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on Networks table.'
    goto errorHandler
 end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end




GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.Networksupdate    Data dello script: 10/07/2003 12.22.23 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Networksupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[Networksupdate]
GO






CREATE     Trigger Networksupdate on dbo.Networks 
for update 
as

BEGIN

if @@ROWCOUNT=0 
BEGIN
-- TRACE	print 'START/END: trigger Networksupdate con ROWCOUNT=0'
	RETURN
END
-- print 'START: trigger Networksupdate'

--Inserito 08/07/2003 F. De Conti
if update(internalupdate) 
BEGIN
-- TRACE	print 'END: trigger Networksupdatee su INTERNALUPDATE'
	return
END





declare @errorNumber int,@errorMsg varchar(255)
declare @ID as int
declare @ID_NetOld as int
declare @InterfOld as varchar(50)
declare @NameOld as varchar(50)
declare @DescOld as varchar(50)
declare @NotesOld as varchar(255)
declare @DTypeOld as varchar(50)
declare @StartOld as datetime
declare @EndOld as datetime
declare @StbyOld as smallint
declare @Upd as smallint

declare @ID_NetNew as int
declare @InterfNew as varchar(50)
declare @NameNew as varchar(50)
declare @DescNew as varchar(50)
declare @NotesNew as varchar(255)
declare @DTypeNew as varchar(50)
declare @StartNew as datetime
declare @EndNew as datetime
declare @StbyNew as smallint

declare @Changed as int 
declare @StByChanged as int 

declare CrsOldNet cursor for select ID_Network, InterfacePort, Name,  Description, Notes, DeviceType, ValidateStartDate, LastModifiedDate, StandByFlag,  InternalUpdate from deleted
declare CrsNewNet cursor for select  ID_Network, InterfacePort, Name,Description, Notes, DeviceType, ValidateStartDate ,LastModifiedDate, StandByFlag from inserted
open CrsOldNet
open CrsNewNet
fetch next from CrsOldNet into    @ID_NetOld,   @InterfOld,   @NameOld, @DescNew, @NotesOld ,  @DTypeOld ,  @StartOld,  @EndOld, @StbyOld,@Upd
fetch next from CrsNewNet into  @ID_NetNew, @InterfNew ,@NameNew, @DescNew, @NotesNew ,@DTypeNew ,@StartNew, @EndNew, @StbyNew
print ' trigger update Networks ' 
declare @cmp as char(5)
set @cmp = 'X#_#Y'
declare @datcmp as datetime
set @datcmp = convert(datetime, '29/07/1969', 103)
WHILE @@FETCH_STATUS = 0
begin
	set @Changed = 0
	set @StByChanged = 0
	if isnull(@StartOld, @datcmp) <> isnull(@StartNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field ValidateStartDate cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@EndOld, @datcmp) <> isnull(@EndNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field LastModifiedDate cannot be modified by user !' 
			goto errorHandler
		end
	end

	--if one of these fields was changed, the trigger will fire the stuff 
	if isnull(@StbyOld, 0) <> isnull(@StbyNew, 0)
		set @StByChanged = 1

	if isnull(@ID_NetOld, -1) <> isnull(@ID_NetNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@InterfOld ,@cmp) <> isnull(@InterfNew,@cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@NotesOld ,@cmp) <> isnull(@NotesNew,@cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@DTypeOld ,@cmp) <> isnull(@DTypeNew,@cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END

HasChanged:
	--the trigger fires if one of the above mentioned fileds are changed
	if @Changed = 1
	begin
		/****************simulate the FK**********/
		--in fact is useless because the ID is autonumber and so , never will be updated; */
		--it will be useful if the table structure will be changed in future
		if update(ID_Network)
		begin
			update PhysInstruments set PhysInstruments.Ref_IDNet =@ID_NetNew  
	 			where PhysInstruments.Ref_IDNet = @ID_NetOld
		end
		/***********************finish  simulate the FK*******************************/

		declare @CrtDate as datetime
		set @CrtDate = GETDATE()

		--#1 update in the current table the new ValidateStartDate value
		update Networks set ValidateStartDate =@CrtDate where Networks.ID_Network = @ID_NetNew

		--#2 the records will be copied into the history table
		insert Hist_Networks (ID_Network, InterfacePort, Name, Description, Notes, DeviceType, ValidateStartDate, ValidateEndDate)
				values(@ID_NetOld,   @InterfOld,@NameOld   ,@DescOld,   @NotesOld ,  @DTypeOld ,  @StartOld , @CrtDate)

	end

	-- handle the case when the StandBy Flag was updated



	if @StByChanged = 1
	begin 
		--test if the StabdByFlag field has the values strictly 1 or 0  
		if @StbyNew <> 0 and @StbyNew <> 1
			begin 
    			select @errorNumber = 30006,
             			@errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    			goto errorHandler
		end
		-- update in PhysInstruments
		update PhI set PhI.StandByFlag = @StbyNew from PhysInstruments PhI where PhI.Ref_IDNet = @ID_NetNew												
	 end

	--update LastModifiedDate at each update operation on the table no metter the field's type
	update Networks set LastModifiedDate = GetDATE() 
		where id_network =@ID_NetNew
-- De Conti, 08/07/2003
-- la precedente riga sostituisce l'esistente, che segue:
--		where id_network in (select id_network from inserted)

	fetch next from CrsOldNet into    @ID_NetOld,   @InterfOld,   @NameOld, @DescNew, @NotesOld ,  @DTypeOld ,  @StartOld,  @EndOld, @StbyOld,@Upd
	fetch next from CrsNewNet into  @ID_NetNew, @InterfNew ,@NameNew, @DescNew, @NotesNew ,@DTypeNew ,@StartNew, @EndNew, @StbyNew
end

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on Networks table.'
    goto errorHandler
end

close CrsOldNet
close CrsNewNet
deallocate CrsOldNet
deallocate CrsNewNet
return

errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
close CrsOldNet
close CrsNewNet
deallocate CrsOldNet
deallocate CrsNewNet
END



GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.PhysInstrumentsdelete    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysInstrumentsdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysInstrumentsdelete]
GO



CREATE  Trigger PhysInstrumentsdelete on dbo.PhysInstruments 
for delete 
as

BEGIN
if @@ROWCOUNT=0 
BEGIN
	RETURN
END


declare @errorNumber as int
declare @errorMsg as varchar(250)


print 'Trigger PhysInstrumentsdelete'

-- Modifica 27/6/2003 F. De Conti
-- Butto via il cursore e uso una select su deleted per copiare le entries nello storico

	insert Hist_PhysInstruments (
		ID_PhysInstrument, 
		NetworkAddress, 
		NetworkSubAddress, 
		Description, 
		ValidateStartDate, 
		ValidateEndDate, 
		FirmwareRelease, 
		Ref_IDDictInstr, 
		Ref_IDNet)
		(select ID_PhysInstrument, 
				NetworkAddress, 
				NetworkSubAddress, 
				Description, 
				ValidateStartDate, 
				GetDate(), 
				FirmwareRelease, 
				Ref_IDDictInstr, 
				Ref_IDNet from deleted)




/*


--copy into History table
declare  CrsPhysInstruments cursor for select 
ID_PhysInstrument, NetworkAddress, NetworkSubAddress, Description, ValidateStartDate,  FirmwareRelease, Ref_IDDictInstr, Ref_IDNet  
from deleted

declare @ID as int
declare @NAdd as varchar(9)
declare @SubNAdd as varchar(10)
declare @Desc as varchar(50)
declare @Start as datetime
declare @FrmRel as smallint
declare @Ref_IDD as int
declare @Ref_IDN as int

open CrsPhysInstruments
fetch next from CrsPhysInstruments into 
@ID, @NAdd ,@SubNAdd ,@Desc ,@Start ,@FrmRel, @Ref_IDD, @Ref_IDN 

WHILE @@FETCH_STATUS = 0
	begin	
	insert Hist_PhysInstruments (
	ID_PhysInstrument, NetworkAddress, NetworkSubAddress, Description, ValidateStartDate, ValidateEndDate, FirmwareRelease, Ref_IDDictInstr, Ref_IDNet)
		values(
	@ID, @NAdd ,@SubNAdd ,@Desc ,@Start ,GETDATE() ,@FrmRel, @Ref_IDD, @Ref_IDN)
	fetch next from CrsPhysInstruments into @ID, @NAdd ,@SubNAdd ,@Desc ,@Start  ,@FrmRel, @Ref_IDD, @Ref_IDN 
	end
CLOSE CrsPhysInstruments
DEALLOCATE CrsPhysInstruments

*/


--delete from PhysResources
-- Butto via la '..where ..in select...' e uso una join su deleted
/*
delete PhysResources where Ref_IDPhysInstrument in (select ID_PhysInstrument from deleted)
*/
	delete PhR
	from PhysResources PhR inner join deleted D on
		PhR.Ref_IDPhysInstrument=D.ID_PhysInstrument



if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution on PhysInstruments table.'
    goto errorHandler
 end


  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.PhysInstrumentsInsert    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysInstrumentsInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysInstrumentsInsert]
GO



CREATE  TRIGGER [PhysInstrumentsInsert] ON dbo.PhysInstruments 
FOR INSERT
AS
Begin

declare @errorNumber as int
declare @errorMsg as varchar(250)
declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1


print 'Trigger PhysInstrumentsInsert'

--test if the StabdByFlag field has the values strictly 1 or 0  
declare @Rows as int
set @Rows = 0
select @Rows = count(ID_PhysInstrument) from inserted 
		where standbyflag <> 0 and standbyflag <> 1
if @Rows <> 0
begin 
    select @errorNumber = 30006,
             @errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    goto errorHandler
end


--simulate a FK constraint
select @RowsRef = count(ID_Network)  from Networks where ID_Network in (select Ref_IDNet from inserted)
select @RowsIns = count(distinct Ref_IDNet)  from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             @errorMsg = 'Data integrity violation between the table Network, field ID_Network and the table PhysInstruments, field Ref_IDNet.'
	goto errorHandler
end

--check if the StandByFlag is on active status on Networks table
--use a cursor cause is possible to use insert .... select .... from TABLE_X
declare @IDNet as int
declare @NetSBF as bit 
declare @PI_SBF as bit 
declare  CrsSBF cursor for select StandByFlag, Ref_IDNet from inserted
open CrsSBF 
fetch next from CrsSBF into @PI_SBF,  @IDNet
while @@fetch_status = 0
begin
	--get the standbyflag for the corresponding Network 
	select @NetSBF = StandByFlag From Networks where ID_Network = @IDNet
	--test the SBF value
	if @NetSBF = 1
	begin
		--forbiden to insert other  value than 1 (inactiv)
		if @PI_SBF <> 1 
		begin 
			select @errorNumber = 30002,
		             @errorMsg = 'The StandByFlag cannot be set to active status while Networks/StandByFlag is set to inactive status.'
			close CrsSBF
			deallocate CrsSBF
			goto errorHandler
		end
	end 
	fetch next from CrsSBF into @PI_SBF,  @IDNet
end 
close CrsSBF
deallocate CrsSBF

--set the internalUpdate to allow the update without the update trigger to fire error message

-- update PhysInstruments set InternalUpdate = 1
--	where id_PhysInstrument in (select id_PhysInstrument from inserted)

update PhI
set 
	InternalUpdate = 1
from PhysInstruments PhI
	inner join inserted i on
	PhI.Id_PhysInstrument=i.Id_PhysInstrument


--set the start date
--update PhysInstruments set validatestartdate = getdate() 
--	where id_PhysInstrument in (select id_PhysInstrument from inserted)

update PhI
set 
	ValidateStartDate = GetDate()
from PhysInstruments PhI
	inner join inserted i on
	PhI.Id_PhysInstrument=i.Id_PhysInstrument




--set LastModifiedDate 
-- De Conti, 09072003
-- Commentato, perch gestito dal trigger di Update
--update [PhysInstruments] set LastModifiedDate = GetDATE() 
--	where id_PhysInstrument in (select id_PhysInstrument from inserted)


--set the internalUpdate to neutral status
--update PhysInstruments set InternalUpdate = 0
--	where id_PhysInstrument in (select id_PhysInstrument from inserted)

update PhI
set 
	InternalUpdate = 0
from PhysInstruments PhI
	inner join inserted i on
	PhI.Id_PhysInstrument=i.Id_PhysInstrument



if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on PhysInstruments table.'
    goto errorHandler
 end
  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.PhysInstrumentsupdate    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysInstrumentsupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysInstrumentsupdate]
GO




CREATE   Trigger PhysInstrumentsupdate on dbo.PhysInstruments 
for update 
as

BEGIN

if @@ROWCOUNT=0 
BEGIN
-- TRACE 	print 'START/END: trigger PhysInstrumentsupdate con ROWCOUNT=0'
	RETURN
END

-- TRACE print'START: trigger PhysInstrumentsupdate'

--Inserito 08/07/2003 F. De Conti
if update(internalupdate) 
BEGIN
-- TRACE 	print 'END: trigger PhysInstrumentsupdate su INTERNALUPDATE'
	return
END

declare @errorNumber int,@errorMsg varchar(255)
declare @ID as int

declare @Changed as int 
declare @StByChanged as int 

declare @IDOld as int 
declare @NtAddOld as varchar(9)
declare @SubNtAddOld as varchar(10)
declare @DescOld as varchar(50)
declare @StartOld as datetime
declare @EndOld as datetime
declare @FrmOld as smallint
declare @Ref_DicOld as int
declare @Ref_NetOld as int
declare @StbyOld as smallint 
declare @Upd as smallint

declare @IDNew as int 
declare @NtAddNew as varchar(9)
declare @SubNtAddNew as varchar(10)
declare @DescNew as varchar(50)
declare @StartNew as datetime
declare @EndNew as datetime
declare @FrmNew as smallint
declare @Ref_DicNew as int
declare @Ref_NetNew as smallint 
declare @StbyNew as smallint

declare CrsOldPI cursor for select  ID_PhysInstrument, NetworkAddress, NetworkSubAddress, Description, ValidateStartDate,  LastModifiedDate, FirmwareRelease, Ref_IDDictInstr, Ref_IDNet , StandbyFlag, internalupdate  from deleted
declare CrsNewPI cursor for select   ID_PhysInstrument, NetworkAddress, NetworkSubAddress, Description, ValidateStartDate,LastModifiedDate,   FirmwareRelease, Ref_IDDictInstr, Ref_IDNet  ,StandByFlag from inserted
open CrsOldPI
open CrsNewPI
fetch next from CrsOldPI   into  @IDOld ,   @NtAddOld ,   @SubNtAddOld ,   @DescOld,  @StartOld ,  @EndOld,    @FrmOld ,   @Ref_DicOld ,   @Ref_NetOld , @StbyOld, @Upd
fetch next from CrsNewPI into  @IDNew , @NtAddNew , @SubNtAddNew , @DescNew, @StartNew ,@EndNew, @FrmNew , @Ref_DicNew , @Ref_NetNew , @StbyNew

declare @cmp as varchar(5)
set @cmp = 'X#_#Y'
declare @datcmp as datetime
set @datcmp = convert(datetime, '29/07/1969', 103)

print'trigger update PhysInstruments'
WHILE @@FETCH_STATUS = 0
begin
	set @Changed = 0
	set @StByChanged = 0

	if isnull(@StartOld, @datcmp) <> isnull(@StartNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field ValidateStartDate cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@EndOld, @datcmp) <> isnull(@EndNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field LastModifiedDate cannot be modified by user !' 
			goto errorHandler
		end
	end

	--if one of these fields was changed, the trigger will fire the stuff 

	if isnull(@StbyOld, 0) <> isnull(@StbyNew, 0)
		set @StByChanged = 1
	if isnull(@IDOld, -1) <> isnull(@IDNew, -1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@NtAddOld ,@cmp) <> isnull(@NtAddNew, @cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@SubNtAddOld,@cmp) <> isnull(@SubNtAddNew,@cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@FrmOld,-1) <> isnull(@FrmNew, -1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@Ref_DicOld, -1) <> isnull(@Ref_DicNew, -1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@Ref_NetOld ,-1)<> isnull(@Ref_NetNew ,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END

	
HasChanged:
	--the trigger fires if one of the above mentioned fileds are changed
	if @Changed = 1
	begin
		/******************* simulate the FK ********************************/

		if update(Ref_IDNet)
		begin
		
			declare @Rows as int
			--check the reference in Networks table
		--	select @Rows = count(Nt.ID_Network) from Networks Nt where Nt.ID_Network in (@Ref_NetNew)
			select @Rows = count(Nt.ID_Network) from Networks Nt where Nt.ID_Network =@Ref_NetNew
			if @Rows = 0
			begin
				select @errorNumber = 30002,
		             		@errorMsg = 'Data integrity violation between the table PhysInstruments, field Ref_IDNet and the table Networks, field ID_Network.'
				goto errorHandler
			end
		end
		--this is useless because the ID is autonumber and so , never will be updated; 
		--it will be useful if the table structure will be changed in future
		if update(ID_PhysInstrument)
		begin
			update PhysResources set PhysResources.Ref_IDPhysInstrument = @IDNew from  PhysResources
				where PhysResources.Ref_IDPhysInstrument = @IDOld
		end
		/*******************finish  simulate the FK********************************/

		declare @CrtDate as datetime
		set @CrtDate = GETDATE()

		--#1 update in the current table the new ValidateStartDate value
		update PhysInstruments set ValidateStartDate =@CrtDate where PhysInstruments.ID_PhysInstrument =  @IDNew		

		--#2 the records will be copied into the history table
		insert Hist_PhysInstruments (
			ID_PhysInstrument, NetworkAddress, NetworkSubAddress, Description, ValidateStartDate, ValidateEndDate, FirmwareRelease, Ref_IDDictInstr, Ref_IDNet)
		values( @IDOld ,   	@NtAddOld ,  	 @SubNtAddOld ,   	@DescOld,  @StartOld , 		 @CrtDate, 	@FrmOld , 	@Ref_DicOld ,   @Ref_NetOld )
		--#3 if ref_IDNet changed, test if StandByFlag on Networks is inactive
		if update(Ref_IdNet)
		begin
			declare @StbFlagNet as smallint 
			set @StbFlagNet = -1
			select @StbFlagNet = Net.StandByFlag from Networks Net where ID_Network = @Ref_NetNew
		   	   if @StbFlagNet = 1 --inactive
			   begin
				-- update the StandByFlag status to inactive , too
				update PhysInstruments set StandByFlag = 1 where Id_PhysInstrument  = @IDNew
			   end
		end
	end  /* Changed=1 */
	-- handle the case when the StandBy Flag was updated
	if @StByChanged = 1
	begin  
		--test if the StabdByFlag field has the values strictly 1 or 0  
		if @StbyNew <> 0 and @StbyNew <> 1
		begin 
    		select @errorNumber = 30006,
             			@errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    			goto errorHandler
		end

		declare @NetSBF as bit 
		--get the standbyflag for the corresponding Network 
		select @NetSBF = StandByFlag From Networks where ID_Network = @Ref_NetNew
		--test the SBF value
		if @NetSBF = 1
		begin
			--forbiden to insert other  value than 1 (inactiv)
			if @StbyNew <> 1 
			begin 
				select @errorNumber = 30002,
		             		@errorMsg = 'The StandByFlag cannot be set to active status while Networks/StandByFlag is set to inactive status.'
				goto errorHandler
			end
		end
		-- update in PhysResources
		update PR set PR.StandByFlag = @StbyNew from Physresources PR where PR.Ref_IDPhysInstrument = @IDNew
	end

	--update LastModifiedDate at each update operation on the table no metter the field's type
	-- De Conti 08072003
	-- La seguente sostituita dalla successiva
	--update PhysInstruments set LastModifiedDate = GetDATE() where ID_PhysInstrument in (select ID_PhysInstrument from inserted)
	update PhysInstruments set LastModifiedDate = GetDATE() where ID_PhysInstrument =@IDNew

	fetch next from CrsOldPI   into  @IDOld ,   @NtAddOld ,   @SubNtAddOld ,   @DescOld,  @StartOld ,  @EndOld,    @FrmOld ,   @Ref_DicOld ,   @Ref_NetOld , @StbyOld, @Upd
	fetch next from CrsNewPI into  @IDNew , @NtAddNew , @SubNtAddNew , @DescNew, @StartNew ,@EndNew, @FrmNew , @Ref_DicNew , @Ref_NetNew , @StbyNew
end


if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on PhysInstruments table.'
    goto errorHandler
end

close CrsOldPI
close CrsNewPI
deallocate CrsOldPI
deallocate CrsNewPI
return

errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
close CrsOldPI
close CrsNewPI
deallocate CrsOldPI
deallocate CrsNewPI
END




GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.PhysResourcesdelete    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysResourcesdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysResourcesdelete]
GO






/****** Oggetto: trigger dbo.PhysResourcesdelete    Data dello script: 16/06/2003 16.03.02 ******/

CREATE     Trigger PhysResourcesdelete on dbo.PhysResources 
for delete 
as
BEGIN


if @@ROWCOUNT=0 
BEGIN
	RETURN
END


declare
	@errorNumber int,
	@errorMsg varchar(255)

print 'Trigger PhysResourcesdelete'
-- update in VirtualResources  Table
-- Commentato 27/6/2003 F. De Conti per accordi con Losso
-- da verificare l'effettiva necessit del ModifiedStatus
/*
update virtualResources set ModifiedStatus = 1 where 
virtualResources.id_virtualresource in
(select T.ID_VirtualResource from VirtualPhysResourceTable T inner join deleted del on del.ID_PhysResource = T.ID_PhysResource)

*/



--delete from VirtualPhysResourceTable
-- Butto via la '..where ..in select...' e uso una join su deleted
/*
delete VirtualPhysResourceTable where ID_PhysResource in (select del.ID_PhysResource from deleted del)
*/
-- TRACE print 'LANCIO delete VPhRT ' + convert (varchar,getdate())
	delete VPhRT
	from VirtualPhysResourceTable VPhRT inner join deleted D on
		VPhRT.ID_PhysResource=D.ID_PhysResource

-- TRACE print 'ESEGUITO delete VPhRT ' + convert (varchar,getdate())

-- Copia su storico
-- Modifica 27/6/2003 F. De Conti
-- Butto via il cursore e uso una select su deleted per copiare le entries nello storico

	insert Hist_PhysResources(
		ID_PhysResource, 
		Name, 
		Description,  
		ValidateStartDate, 
		ValidateEndDate, 
		Ref_IDPhysInstrument, 
		VariableType, 
		VariableIndex, 
		ResourceCode, 
		MeasureUnitID, 
		ResolutionID, 
		AcqFrequency)
		(select ID_PhysResource, 
			Name, 
			Description, 
			ValidateStartDate,
			GetDate(), 
			Ref_IDPhysInstrument, 
			ResourceIndex,
			MeasureUnitID, 
			ResolutionID,
			AcqFrequency, 
			ResourceType,
			ResourceCode from deleted)


/*

--copy to history table
declare  CrsPhysResources cursor for select 
ID_PhysResource, Name, Description, ValidateStartDate, Ref_IDPhysInstrument, 
ResourceIndex,MeasureUnitID, ResolutionID,AcqFrequency, resourceType,ResourceCode
from deleted

declare @ID as int
declare @Name as varchar(50)
declare @Desc as varchar(50)
declare @Start as datetime
declare @Ref_IDPhysInstr as int
declare @VarT as smallint
declare @VarI as int
declare @ResCode as int
declare @MUnitID as int
declare @RezID as int
declare @AcqF as int

open CrsPhysResources
fetch next from CrsPhysResources into 
@ID,@Name ,@Desc ,@Start ,@Ref_IDPhysInstr ,@VarI ,@MUnitID ,@RezID , @AcqF, @VarT ,@ResCode

WHILE @@FETCH_STATUS = 0
	begin	
	insert Hist_PhysResources(
	ID_PhysResource, NaME, Description,  ValidateStartDate, ValidateEndDate, Ref_IDPhysInstrument, VariableType, VariableIndex, ResourceCode, MeasureUnitID, ResolutionID, AcqFrequency)
values(@ID,             @Name ,@Desc ,          @Start ,          GETDATE(),     @Ref_IDPhysInstr ,    @VarT ,        @VarI ,       @ResCode,    @MUnitID       ,@RezID ,         @AcqF )
	fetch next from CrsPhysResources into 
	@ID,@Name ,@Desc ,@Start ,@Ref_IDPhysInstr ,@VarI ,@MUnitID ,@RezID , @AcqF, @VarT ,@ResCode
	end
CLOSE CrsPhysResources
DEALLOCATE CrsPhysResources

*/


if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution on PhysResources table.'
    goto errorHandler
 end
  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END







GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.PhysResourcesInsert    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysResourcesInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysResourcesInsert]
GO



CREATE   TRIGGER [PhysResourcesInsert] ON dbo.PhysResources 
FOR INSERT 
AS

begin

declare @errorNumber as int
declare @errorMsg as varchar(250)
declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1

print 'Trigger PhysResourcesInsert'
--test if the StabdByFlag field has the values strictly 1 or 0  
declare @Rows as int
set @Rows = 0
select @Rows = count(ID_PhysResource) from inserted 
		where standbyflag <> 0 and standbyflag <> 1
if @Rows <> 0
begin 
    select @errorNumber = 30006,
             @errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    goto errorHandler
end

--simulate a FK constraint
select @RowsRef = count(ID_PhysInstrument)  from PhysInstruments where ID_PhysInstrument in (select Ref_IDPhysInstrument from inserted)
select @RowsIns = count(distinct Ref_IDPhysInstrument) from inserted

if @RowsIns > @RowsRef
begin 
     select @errorNumber = 30002,
             @errorMsg = 'Data integrity violation between the table PhysInstruments, field ID_PhysInstrument and the table PhysResources, field Ref_IDPhysInstrument.'
    goto errorHandler
end


--check if the StandByFlag is on active status on PhysInstruments table
-- De Conti, 09072003
-- Tutto il blocco che usa il cursore viene buttato via e sostituito
-- con il codice SQL che segue; il codice preesistente  conservato per documentazione

declare @NumStByFlagIncorrect as int
set @NumStByFlagIncorrect=0
select @NumStByFlagIncorrect= count(*) from
	inserted i inner join PhysInstruments PhI 
		on i.Ref_IDPhysInstrument=PhI.ID_PhysInstrument
	where PhI.StandByFlag=1 and
		  i.StandByFlag<>1

if @NumStByFlagIncorrect>0
	BEGIN
		select @errorNumber = 30002,
	             @errorMsg = 'The StandByFlag cannot be set to active status while PhysInstruments/StandByFlag is set to inactive status.'
		goto errorHandler
	END

/*
--check if the StandByFlag is on active status on PhysInstruments table
--use a cursor cause is possible to use insert .... select .... from TABLE_X
declare @PR_ID as int
declare @PI_SBF as bit 
declare @PR_SBF as bit 
declare  CrsSBF1 cursor for select StandByFlag, Ref_IDPhysInstrument from inserted
open CrsSBF1 
fetch next from CrsSBF1 into @PR_SBF,  @PR_ID
while @@fetch_status = 0
begin
	--get the standbyflag for the corresponding Network 
	select @PI_SBF = StandByFlag From PhysInstruments where ID_PhysInstrument = @PR_ID
	--test the SBF value
	if @PI_SBF = 1
	begin
		--forbiden to insert other  value than 1 (inactiv)
		if @PR_SBF<> 1 
		begin 
			select @errorNumber = 30002,
		             @errorMsg = 'The StandByFlag cannot be set to active status while PhysInstruments/StandByFlag is set to inactive status.'
			close CrsSBF1
			deallocate CrsSBF1
			goto errorHandler
		end
	end 
	fetch next from CrsSBF1 into @PR_SBF,  @PR_ID
end 
close CrsSBF1
deallocate CrsSBF1

*/

--set the internalUpdate to allow the update without the update trigger to fire error message
--update PhysResources set InternalUpdate = 1
--	where id_PhysResource in (select id_PhysResource from inserted)

update PhR
set 
	InternalUpdate = 1
from PhysResources PhR
	inner join inserted i on
	PhR.id_PhysResource=i.id_PhysResource


--set the start date
--update PhysResources set validatestartdate = getdate()
--	where id_PhysResource in (select id_PhysResource from inserted)

update PhR
set 
	ValidateStartDate = GetDate()
from PhysResources PhR
	inner join inserted i on
	PhR.id_PhysResource=i.id_PhysResource



--set LastModifiedDate 
-- De Conti, 09072003
-- Commentato, perch gestito dal trigger di Update
--update [PhysResources] set LastModifiedDate = GetDATE() 
--	where id_PhysResource in (select id_PhysResource from inserted)

--set the internalUpdate to neutral status
--update PhysResources set InternalUpdate = 0
--	where id_PhysResource in (select id_PhysResource from inserted)

update PhR
set 
	InternalUpdate = 0
from PhysResources PhR
	inner join inserted i on
	PhR.id_PhysResource=i.id_PhysResource


--check if there is a 0 value to be inserted
declare @RowsFr as int 
set @RowsFr = 0
select @RowsFr = count(id_PhysResource) from inserted where isnull(AcqFrequency,-1) = 0 
if @RowsFr > 0 
begin 
	select @errorNumber = 30004,
	@errorMsg = 'The 0 value is not allowed for the AcqFrequency field !' 
	goto errorHandler
end


if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on PhysResources table.'
    goto errorHandler
 end


  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end





GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.PhysResourcesupdate    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysResourcesupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[PhysResourcesupdate]
GO





/****** Oggetto: trigger dbo.PhysResourcesupdate    Data dello script: 16/06/2003 16.03.02 ******/







CREATE             Trigger PhysResourcesupdate on dbo.PhysResources 
for update 
as
if @@ROWCOUNT=0
BEGIN
	return
END

if update(internalupdate) 
BEGIN
	return
END

BEGIN

print 'START: trigger PhysResourcesupdate'




declare @errorNumber int,@errorMsg varchar(255)

declare @Changed as int 
-- set @Changed = 0

declare @StByChanged as int 
-- set @StByChanged = 0

declare @IDOld as int 
declare @NameOld as varchar(50)
declare @DescOld as varchar(50)
declare @StartOld as datetime
declare @EndOld as Datetime
declare @Ref_PIOld as int
declare @ResIdxOld as int
declare @MesUnitOld as int
declare @ResolOld as int
declare @FrecqOld as int 
declare @ResTOld as int 
declare @ResCOld as int 
declare @StbyOld as smallint 
declare @Upd as smallint

declare @IDNew as int 
declare @NameNew as varchar(50)
declare @DescNew as varchar(50)
declare @StartNew as datetime
declare @EndNew as datetime
declare @Ref_PINew as int
declare @ResIdxNew as int
declare @MesUnitNew as int
declare @ResolNew as int
declare @FrecqNew as int 
declare @ResTNew as int 
declare @ResCNew as int 
declare @StbyNew as smallint


--temporaneo

--return


declare CrsOldPR cursor for select     ID_PhysResource, Name, Description, ValidateStartDate,LastModifiedDate, Ref_IDPhysInstrument, ResourceIndex, MeasureUnitID, ResolutionID,AcqFrequency, resourceType,ResourceCode, StandByFlag, InternalUpdate  from deleted
declare CrsNewPR cursor for select   ID_PhysResource, Name, Description, ValidateStartDate,LastModifiedDate, Ref_IDPhysInstrument, ResourceIndex, MeasureUnitID, ResolutionID,AcqFrequency, resourceType,ResourceCode ,StandByFlag  from inserted
open CrsOldPR
open CrsNewPR
fetch next from CrsOldPR   into  @IDOld,    @NameOld,   @DescOld,     @StartOld , @EndOld, @Ref_PIOld ,   @ResIdxOld ,   @MesUnitOld ,   @ResolOld ,   @FrecqOld ,     @ResTOld ,   @ResCOld,   @StbyOld, @Upd
fetch next from CrsNewPR into  @IDNew , @NameNew, @DescNew, @StartNew , @EndNew, @Ref_PINew , @ResIdxNew , @MesUnitNew , @ResolNew , @FrecqNew , @ResTNew , @ResCNew, @StbyNew

declare @datcmp as datetime
set @datcmp = convert(datetime, '29/07/1969', 103)

--print 'trigger PhysResourcesupdate'

--alter table VirtualPhysResourceTable disable trigger VirtualPhysResourceTableUPDATE

WHILE @@FETCH_STATUS = 0
begin
	-- De Conti, 09072003
	-- Spostate qui le due inizializzazioni: prima erano in testa al trigger
	set @Changed = 0
	set @StByChanged = 0

	--if one of these fields was changed, the trigger will fire the stuff 
	if isnull(@IDOld ,-1)<> isnull(@IDNew,-1)
		set @Changed = 1
	if isnull(@StartOld, @datcmp) <> isnull(@StartNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The  ValidateStartDate field cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@EndOld, @datcmp) <> isnull(@EndNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The  LastModifiedDate field cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@Ref_PIOld ,-1) <> isnull(@Ref_PINew,-1)
		set @Changed = 1
	if isnull(@MesUnitOld,-1 )<> isnull(@MesUnitNew,-1)
		set @Changed = 1
	if isnull(@ResIdxOld ,-1) <> isnull(@ResIdxNew,-1)
		set @Changed = 1	
	if isnull(@ResolOld ,-1) <> isnull(@ResolNew,-1)
		set @Changed = 1
	if isnull(@FrecqOld,-1) <> isnull(@FrecqNew,-1)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		   begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The AcqFrequency field cannot be modified by user !' 

			goto errorHandler
		   end
		else
		--the 0 value is not allowed for the AcqGrequency filed
		   begin
			if isnull(@FrecqNew,-1) <= 0
				begin 
					select @errorNumber = 30004,
	             				@errorMsg = 'A negative or zero value is not allowed for the AcqFrequency field !' 
					goto errorHandler
				end  			
		   end
	end

	if isnull(@ResTOld,-1) <> isnull(@ResTNew,-1)
		set @Changed = 1
	if isnull(@ResCOld,-1) <> isnull(@ResCNew,-1)
begin
print 'Resource code old:' + convert(varchar(3),@ResCOld)
print 'Resource code new:' + convert(varchar(3),@ResCNew)

		set @Changed = 1
end
	if isnull(@StbyOld, 0) <> isnull(@StbyNew, 0)
		set @StByChanged = 1



	--the trigger fires if one of the above mentioned fileds are changed
	if @Changed = 1
	begin
		/******************* simulate the FK ********************************/

		if update(Ref_IDPhysInstrument)
		begin
			declare @Rows as int
			--check the reference in PhysInstruments table
			select @Rows = count(PhI.ID_PhysInstrument) from PhysInstruments PhI where PhI.ID_PhysInstrument in (@Ref_PINew)
			if @Rows = 0
			begin
				select @errorNumber = 30002,
				@errorMsg = 'Data integrity violation between the table PhysResources, field Ref_ID_PhysInstrument and the table PhysInstruments, field ID_PhysInstrument.'
				goto errorHandler
			end
		end
		--this is useless because the ID is autonumber and so , never will be updated; 
		--it will be useful if the table structure will be changed in future
		if update(ID_PhysResource)
		begin
			--
			-- evito deadlock trigger
			--
			alter table VirtualPhysResourceTable disable trigger VirtualPhysResourceTableUPDATE
			
			update VirtualPhysResourceTable set VirtualPhysResourceTable.ID_PhysResource = @IDNew from VirtualPhysResourceTable
		 			where VirtualPhysResourceTable.ID_PhysResource = @IDOld
			--
			-- riabilito trigger
			--
			alter table VirtualPhysResourceTable enable trigger VirtualPhysResourceTableUPDATE
			
		end
		/*******************finish  simulate the FK********************************/

		declare @CrtDate as datetime
		set @CrtDate = GETDATE()

		--#1 update in the current table the new ValidateStartDate value
		update PhysResources set ValidateStartDate =@CrtDate where PhysResources.ID_PhysResource = @IDNew			
	
		--#2 the records will be copied into the history table
		insert Hist_PhysResources(
			ID_PhysResource, Name, Description,  ValidateStartDate, ValidateEndDate, Ref_IDPhysInstrument, VariableType, VariableIndex, ResourceCode, MeasureUnitID, ResolutionID, AcqFrequency)
		  values(@IDOld,    @NameOld,   @DescOld,     @StartOld ,           @CrtDate,            @Ref_PIOld ,               @ResTOld ,   @ResolOld,   @ResCOld,        @MesUnitOld ,  @ResolOld  ,   @FrecqOld )

		--#3 if Ref_IdPhysInstrument changed, test if StandByFlag on PhysInstruments is inactive
		if update(Ref_IdPhysInstrument)
		begin
			declare @StbFlagPI as smallint 
			set @StbFlagPI = -1
			select @StbFlagPI = PhI.StandByFlag from PhysInstruments PhI where PhI.Id_PhysInstrument = @Ref_PINew
		   	   if @StbFlagPI = 1 --inactive
			   begin
				-- update the StandByFlag status to inactive , too
				update PhysResources set StandByFlag = 1 where Id_PhysResource = @IDNew
			   end
		end
	end

	-- handle the case when the StandBy Flag was updated
	if @StByChanged = 1
	begin 
		--test if the StabdByFlag field has the values strictly 1 or 0  
		if @StbyNew <> 0 and @StbyNew <> 1 
		begin 
    			select @errorNumber = 30006,
             			@errorMsg = 'StandByFlag valid values are only: 0 (active) and 1 (inactive). Please input a valid value.'
    			goto errorHandler
		end


		declare @PI_SBF as bit 
		--get the standbyflag for the corresponding instrument 
		select @PI_SBF = StandByFlag From PhysInstruments where ID_PhysInstrument = @Ref_PINew

		--test the SBF value
		if @PI_SBF = 1
		begin
			--forbidden to upadate to other  value than 1 (inactiv)
			if @StbyNew <> 1 
			begin 
				select @errorNumber = 30002,
		             		@errorMsg = 'The StandByFlag cannot be set to active status while PhysInstrument/StandByFlag is set to inactive status.'

				goto errorHandler
			end
		end
		
		--update in VirtualResources	
		--search if at least one Physical resoucrce has the StandByFlag set to 1		
		declare @IDVR as int
		declare @Sdf  as smallint
		declare @find as int 
		declare  Crs1 Cursor for
			select VPRT.ID_VirtualResource from VirtualPhysResourceTable VPRT where VPRT.ID_PhysResource = @IDNew
	
		open Crs1
		--get the VR's which are bounded to the current PR in the cursor Crs1 (i.e.@IDNew)
		fetch next from Crs1 into @IDVR
		while @@fetch_status = 0
		begin 
			set @find = 0
			declare  CrsAux Cursor for
				select PR.Standbyflag from VirtualPhysResourceTable VPRT inner join  	PhysResources PR	
					on VPRT.ID_PhysResource = PR.ID_PhysResource where VPRT.ID_VirtualResource = @IDVR
			open CrsAux
			--get all PR's bounded to the current VR in the cursor CrsAux (i.e. @IDVR)
			fetch next from CrsAux into @Sdf
			while @@fetch_status = 0
			begin 
				--test if at least one PR has the standbyflag set to 1
				if @Sdf = 1 
				begin
					set @find = 1 --found one
					BREAK
				end
				else 
					set @find = 0 --found nothing
				fetch next from CrsAux into @Sdf
			end
			close CrsAux
			deallocate CrsAux

			--set the internalUpdate to allow the update without the update trigger to fire error message
			update VirtualResources set InternalUpdate = 1 where ID_VirtualResource = @IDVR
			if @find = 0
				--all the StandByFlag are 0 / PR's
				update VirtualResources set StandByFlag = 0 where ID_VirtualResource = @IDVR
			else
				--at least one StandByFlag is 1
				update VirtualResources set StandByFlag = 1 where ID_VirtualResource = @IDVR
			--set the internalUpdate to neutral status
			update VirtualResources set InternalUpdate = 0 where ID_VirtualResource = @IDVR

			fetch next from Crs1 into @IDVR
		end
		close Crs1
		deallocate Crs1
	end

	--update LastModifiedDate at each update operation on the table no metter the field's type
	--update PhysResources set LastModifiedDate = GetDATE() 
	--	where id_PhysResource in (select id_PhysResource from inserted)

	update PhysResources 
	set LastModifiedDate = GetDATE() 
	where id_PhysResource =@idnew

	fetch next from CrsOldPR   into  @IDOld,    @NameOld,   @DescOld,     @StartOld , @EndOld, @Ref_PIOld ,   @ResIdxOld ,   @MesUnitOld ,   @ResolOld ,   @FrecqOld ,     @ResTOld ,   @ResCOld,   @StbyOld, @Upd
	fetch next from CrsNewPR into  @IDNew , @NameNew, @DescNew, @StartNew , @EndNew, @Ref_PINew , @ResIdxNew , @MesUnitNew , @ResolNew , @FrecqNew , @ResTNew , @ResCNew, @StbyNew
end

--alter table VirtualPhysResourceTable enable trigger VirtualPhysResourceTableUPDATE


if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on PhysResources table.'
    goto errorHandler
end

close CrsOldPR
close CrsNewPR
deallocate CrsOldPR
deallocate CrsNewPR


print 'END: trigger PhysResourcesupdate'


return

errorHandler:
  raiserror @errorNumber @errorMsg
--alter table VirtualPhysResourceTable enable trigger VirtualPhysResourceTableUPDATE

  rollback transaction
close CrsOldPR
close CrsNewPR
deallocate CrsOldPR
deallocate CrsNewPR
END


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.VirtualInstrumentsdelete    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualInstrumentsdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualInstrumentsdelete]
GO


CREATE Trigger VirtualInstrumentsdelete on dbo.VirtualInstruments 
for delete 
as

BEGIN
  declare
	@errorNumber int,
	@errorMsg varchar(255)
print 'Trigger VirtualInstrumentsdelete'

--delete in VirtuaResources
delete VirtualResources where Ref_IDVirtualInstr in (select id_VirtualInstrument from deleted)

--copy to history table
declare  CrsVirtInstruments cursor for select 
ID_VirtualInstrument, Name, Description, ValidateStartDate,Notes, RegSpeedHist, RegSpeedFlash, InstrumentClassCode
from deleted

declare @ID as int
declare @Name as varchar(50)
declare @Desc as varchar(50)
declare @Start as datetime
declare @Notes as varchar(255)
declare @RegH as smallint
declare @RegF as smallint
declare @ICC as int


open CrsVirtInstruments
fetch next from CrsVirtInstruments into 
@ID,@Name ,@Desc ,@Start, @Notes,@RegH ,@RegF ,@ICC 

WHILE @@FETCH_STATUS = 0
	begin	
	insert Hist_VirtualInstruments(
	ID_VirtualInstrument, Name, Description, ValidateStartDate, ValidateEndDate, Notes, RegSpeedHist, RegSpeedFlash, InstrumentClassCode)
values (@ID,		     @Name ,@Desc ,	@Start, 	   GETDATE(),       @Notes,@RegH ,        @RegF ,            @ICC)
	fetch next from CrsVirtInstruments into 
	@ID,@Name ,@Desc ,@Start, @Notes,@RegH ,@RegF ,@ICC 
	end
CLOSE CrsVirtInstruments
DEALLOCATE CrsVirtInstruments


if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution onVirtualInstruments table.'
    goto errorHandler
end


  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.VirtualInstrumentsInsert    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualInstrumentsInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualInstrumentsInsert]
GO



CREATE  TRIGGER [VirtualInstrumentsInsert] ON dbo.VirtualInstruments 
FOR INSERT
AS
Begin

declare @errorNumber as int
declare @errorMsg as varchar(250)
declare @Rows as int 
print 'Trigger VirtualInstrumentsInsert'

declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1

--simulate a FK constraint
select @RowsRef = count(InstrumentClassCode)  from VirtualInstrumentClasses where InstrumentClassCode in (select InstrumentClassCode from inserted)
select @RowsIns = count(distinct InstrumentClassCode) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             @errorMsg = 'Data integrity violation between the table VirtualInstrumentClasses, field InstrumentClassCode and the table VirtualInstruments, field InstrumentClassCode.'
	goto errorHandler
end

--set the internalUpdate to allow the update without the update trigger to fire error message
update VirtualInstruments set InternalUpdate = 1
	where id_VirtualInstrument in (select id_VirtualInstrument from inserted)
--set the start date
update VirtualInstruments set validatestartdate = getdate() , StandByFlag=2
	where id_VirtualInstrument in (select id_VirtualInstrument from inserted)

/*
--set LastModifiedDate 
update dbo.VirtualInstruments set LastModifiedDate = GetDATE() 
	where id_VirtualInstrument in (select id_VirtualInstrument from inserted)


--set the StandByFlag to 2 <=> neutral status immediately after insert operation
update VirtualInstruments set StandByFlag = 2
	where id_VirtualInstrument in (select id_VirtualInstrument from inserted)
*/

--set the internalUpdate to neutral status
update VirtualInstruments set InternalUpdate = 0
	where id_VirtualInstrument in (select id_VirtualInstrument from inserted)


if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on VirtualInstruments table.'
    goto errorHandler
 end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.VirtualInstrumentsupdate    Data dello script: 10/07/2003 12.22.24 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualInstrumentsupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualInstrumentsupdate]
GO








CREATE      Trigger VirtualInstrumentsupdate on dbo.VirtualInstruments 
for update 
as

BEGIN

if @@ROWCOUNT=0 
BEGIN
-- TRACE 	print 'START/END: trigger VirtualInstrumentsupdate con ROWCOUNT=0'
	RETURN
END

-- TRACE print'START: trigger VirtualInstrumentsupdate'

--Inserito 26/6/2003 F. De Conti
if update(internalupdate) 
BEGIN
-- TRACE 	print 'END: trigger VirtualInstrumentsupdate su INTERNALUPDATE'
	return
END
--return





declare @errorNumber int,@errorMsg varchar(255)
declare @Changed as int 

declare @IDOld as int
declare @NameOld as varchar(50)
declare @DescOld as varchar(50)	
declare @StartOld as datetime
declare @EndOld as datetime
declare @StdfOld as smallint
declare @NotesOld as varchar(255)
declare @RegHOld as smallint
declare @RegFOld as smallint
declare @ICCOld as int
declare @Upd as smallint

declare @IDNew as int
declare @NameNew as varchar(50)
declare @DescNew as varchar(50)	
declare @StartNew as datetime
Declare @EndNew as datetime
declare @StdfNew as smallint
declare @NotesNew as varchar(255)
declare @RegHNew as smallint
declare @RegFNew as smallint
declare @ICCNew as int

declare CrsOldVI cursor for select   ID_VirtualInstrument, Name, Description,  ValidateStartDate, LastModifiedDate, StandByFlag, Notes, RegSpeedHist, RegSpeedFlash, InstrumentClassCode, InternalUpdate from deleted
declare CrsNewVI cursor for select ID_VirtualInstrument, Name, Description,  ValidateStartDate, LastModifiedDate, StandByFlag, Notes, RegSpeedHist, RegSpeedFlash, InstrumentClassCode from inserted

open CrsOldVI
open CrsNewVI
fetch next from CrsOldVI   into @IDOld ,   @NameOld,   @DescOld,   @StartOld ,   @EndOld,   @StdfOld,  @NotesOld ,   @RegHOld ,   @RegFOld ,   @ICCOld, @Upd
fetch next from CrsNewVI into @IDNew ,@NameNew, @DescNew,  @StartNew , @EndNew, @StdfNew,  @NotesNew , @RegHNew , @RegFNew , @ICCNew

declare @cmp as char
set @cmp = 'X#_#Y'
declare @datcmp as datetime
set @datcmp = convert(datetime, '29/07/1969', 103)


WHILE @@FETCH_STATUS = 0
begin
	set @Changed = 0
	--if one of these fields was changed, the trigger will fire the stuff 
	if isnull(@IDOld ,-1)<> isnull(@IDNew ,-1)
		set @Changed = 1
	if isnull(@StartOld, @datcmp) <> isnull(@StartNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field ValidateStartDate cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@EndOld, @datcmp) <> isnull(@EndNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field LastModifiedDate cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@StdfOld, -1) <> isnull(@StdfNew, -1)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field StandbyFlag cannot be modified by user !' 
			goto errorHandler
		end
	end
	if isnull(@NotesOld ,@cmp)<> isnull(@NotesNew ,@cmp)
		set @Changed = 1

-- AL 20/05/2003 Commento per evitare di avere strimenti nelle tabelle di storico (Hist_VirtualInstruments)
--               a seguito di una modifica delle freq. di registrazione
--	if isnull(@RegHOld ,-1)<> isnull(@RegHNew  ,-1)
--		set @Changed = 1
--	if isnull(@RegFOld ,-1)<> isnull(@RegFNew ,-1)
--		set @Changed = 1

	if isnull(@ICCOld ,-1)<> isnull(@ICCNew  ,-1)
		set @Changed = 1

	--the trigger fires if one of the above mentioned fileds are changed
	if @Changed = 1
	begin
		/******************* simulate the FK ********************************/
		if update(InstrumentClassCode)
		begin
			declare @Rows as int
			--the 0 value is for "VI without Instrument class" ; 0 will be accepted although it could not be in the VirtualInstrumentClasses
			--the NULL value is not accepted; is transformed in -1 value
			if isnull(@ICCNew, -1) = -1 or @ICCNew > 0
			begin
				--check the reference in VirtualInstrumentClasses table
				select @Rows = count(VIC.InstrumentClassCode) from VirtualInstrumentClasses VIC where VIC.InstrumentClassCode in (@ICCNew)
				if @Rows = 0
				begin
					select @errorNumber = 30002,

	             				@errorMsg = 'Data integrity violation between the table VirtualInstruments, field InstrumentClassCode and the table VirtualInstrumentClasses, field InstrumentClassCode.'
					goto errorHandler
				end
			end
		end
		--this is useless because the ID is autonumber and so , never will be updated; 
		--it will be useful if the table structure will be changed in future
		if update(ID_VirtualInstrument)
		begin
		
			update VirtualInstrumentCategoryTable set VirtualInstrumentCategoryTable.VirtualInstrumentCode = @IDNew from VirtualInstrumentCategoryTable
		 			                               where VirtualInstrumentCategoryTable.VirtualInstrumentCode = @IDOld
			update VirtualResources set VirtualResources.Ref_IDVirtualInstr = @IDNew from VirtualResources
		 			         where VirtualResources.Ref_IDVirtualInstr = @IDOld
		end
		/*******************finish  simulate the FK********************************/

		declare @CrtDate as datetime
		set @CrtDate = GETDATE()
		--#1 update in the current table the new ValidateStartDate value
		update VirtualInstruments set ValidateStartDate =@CrtDate where VirtualInstruments.ID_VirtualInstrument = @IDNew			

		--#2 the records will be copied into the history table
		insert Hist_VirtualInstruments( 
			ID_VirtualInstrument, Name, Description, ValidateStartDate, ValidateEndDate, Notes,       RegSpeedHist,   RegSpeedFlash,   InstrumentClassCode)
		values (@IDOld ,                @NameOld, @DescOld,@StartOld ,     @CrtDate,           @NotesOld , @RegHOld ,     @RegFOld ,        @ICCOld)
		
	end

	--update LastModifiedDate at each update operation on the table no metter the field's type
	-- De Conti 09072003
	-- La seguente sostituisce l'esistente, commentata subito dopo
	 update VirtualInstruments set LastModifiedDate = GetDATE() 
		where id_VirtualInstrument =@IdNew
--	 update dbo.VirtualInstruments set LastModifiedDate = GetDATE() 
--		where id_VirtualInstrument in (select id_VirtualInstrument from inserted)

	fetch next from CrsOldVI   into @IDOld ,   @NameOld,   @DescOld,   @StartOld ,   @EndOld,   @StdfOld,  @NotesOld ,   @RegHOld ,   @RegFOld ,   @ICCOld, @Upd
	fetch next from CrsNewVI into @IDNew ,@NameNew, @DescNew,  @StartNew , @EndNew, @StdfNew,  @NotesNew , @RegHNew , @RegFNew , @ICCNew

end



if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on VirtualInstruments table.'
    goto errorHandler
end

close CrsOldVI
close CrsNewVI
deallocate CrsOldVI
deallocate CrsNewVI

-- TRACE print 'END: trigger VirtualInstrumentsupdate'

  return
errorHandler:
close CrsOldVI
close CrsNewVI
deallocate CrsOldVI
deallocate CrsNewVI
  raiserror @errorNumber @errorMsg
  rollback transaction

END




GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.VirtualPhysResourceTableDEL    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualPhysResourceTableDEL]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualPhysResourceTableDEL]
GO







/****** Oggetto: trigger dbo.VirtualPhysResourceTableDEL    Data dello script: 16/06/2003 16.03.03 ******/



CREATE      TRIGGER [VirtualPhysResourceTableDEL] ON [VirtualPhysResourceTable] 
FOR DELETE 
AS
BEGIN

if @@ROWCOUNT=0 
BEGIN
	RETURN
END




-- TRACE print 'START:trigger VirtualPhysResourceTableDEL'
--update frequency
-- IF EXISTS(SELECT name FROM sysobjects WHERE name = 'UpdateFrequency' AND type = 'P')
--    exec [dbo].UpdateFrequency
--update frequency on PhysResources
--
-- F. De Conti 13/06/2003
-- Riga seguente commentata e sostituita dalla successiva
-- Poi rivisto per limitare l'update alle sole righe coinvolte: prima il blocco per deleted,
-- poi per inserted
-- 10072003: rivisto, per l'introduzione della vista aggiornabile [Vw_AcqFrequencies4UPDT]
--exec [dbo].UpdateFrequency
--exec st_UpdateAllFrequencies
-- Deleted:
update  PH 
	set ph.internalupdate=1	
	from physresources PH join deleted D on
	     ph.ID_PhysResource =D.ID_PhysResource
--	where ph.ID_PhysResource in 
--		(select ID_PhysResource from deleted group by ID_PhysResource)
/*
update  PH 
	set ph.acqfrequency=Vw_AcqFrequencies.MinVirtualAcqFrequency
	FROM (physresources ph INNER JOIN dbo.Vw_AcqFrequencies ON 
	     ph.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource) 
	     inner join deleted D on 
	     ph.ID_PhysResource =D.ID_PhysResource
	where ph.ID_PhysResource in 
		(select ID_PhysResource from deleted group by ID_PhysResource)
*/

update  PH 
	set acqfrequency=MinVirtualAcqFrequency
	FROM Vw_AcqFrequencies4UPDT ph  
	     inner join deleted D on 
	     ph.ID_PhysResource =D.ID_PhysResource


update  PH 
	set ph.internalupdate=0	
	from physresources PH join deleted D on
	     ph.ID_PhysResource =D.ID_PhysResource
--	where ph.ID_PhysResource in 
--		(select ID_PhysResource from deleted group by ID_PhysResource)


declare @errorNumber as int
declare @errorMsg as varchar(250)

-- Seguente blocco concursore commentato il 27/6/2003 affinch una VR sia posta con 
-- StandByFlag pari a 2 se una qualunque risorsa fisica necessaria viene a mancare

-- Sostituito con le seguenti 3 clausole:
	update VR set InternalUpdate=1 
	from  VirtualResources VR INNER JOIN  Deleted D 
		ON VR.ID_VirtualResource = D.ID_VirtualResource 


	update VR set StandByFlag=2 
	from  VirtualResources VR INNER JOIN  Deleted D 
		ON VR.ID_VirtualResource = D.ID_VirtualResource 

	update VR set InternalUpdate=0 
	from  VirtualResources VR INNER JOIN  Deleted D 
		ON VR.ID_VirtualResource = D.ID_VirtualResource 

/*


--update in VirtualResources the StandByFlag field

declare @ID_VR as int
declare  CrsVRTDel Cursor for
	select ID_VirtualResource from deleted 
open CrsVRTDel
--for each item deleted
fetch next from CrsVRTDel into @ID_VR 
while @@fetch_status = 0
begin
	exec updateVR @ID_VR	
	fetch next from CrsVRTDel into @ID_VR
end
close CrsVRTDel
deallocate CrsVRTDel



*/


if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on VirtualPhysResourceTable table.'
    goto errorHandler
 end

-- TRACE print 'END:trigger VirtualPhysResourceTableDEL'

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

END




GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.VirtualPhysResourceTableInsert    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualPhysResourceTableInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualPhysResourceTableInsert]
GO







CREATE        TRIGGER [VirtualPhysResourceTableInsert] ON [VirtualPhysResourceTable] 
FOR INSERT
AS

begin


declare @p  varchar(40)
declare @CurTime datetime

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'START TRG: ' + @p


declare @errorNumber as int
declare @errorMsg as varchar(250)
declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1


print ' trigger VirtualPhysResourceTableInsert'
--simulate a FK constraint
select @RowsRef = count(PR.ID_PhysResource)  from PhysResources PR where PR.ID_PhysResource in (select ID_PhysResource from inserted)
select @RowsIns = count(distinct ID_PhysResource) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             	@errorMsg = 'Data integrity violation between the table VirtualPhysResourceTable, field ID_PhysResource and the table PhysResources, field ID_PhysResource.'
	goto errorHandler
	
end

set @RowsRef = -1
set @RowsIns = -1

--simulate a FK constraint
select @RowsRef = count(VR.ID_VirtualResource)   from VirtualResources VR where VR.ID_VirtualResource in (select ID_VirtualResource from inserted)
select @RowsIns = count(distinct ID_VirtualResource) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             	@errorMsg = 'Data integrity violation between the table VirtualPhysResourceTable, field ID_VirtualResource and the table VirtualResources, field ID_VirualResource.'
	goto errorHandler
	
end

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'DOPO Verifica FKEY TRG: ' + @p
--update in PhysInstruments the Frequecy 
--IF EXISTS(SELECT name FROM sysobjects WHERE name = 'UpdateFrequency' AND type = 'P')
--    exec [dbo].UpdateFrequency
--update frequency on PhysResources
--
-- F. De Conti 13/06/2003
-- Riga seguente commentata e sostituita dalla successiva
-- Poi rivisto per limitare l'update alle sole righe coinvolte: prima il blocco per deleted,
-- poi per inserted
-- 10072003: rivisto, per l'introduzione della vista aggiornabile [Vw_AcqFrequencies4UPDT]
--exec [dbo].UpdateFrequency
--exec st_UpdateAllFrequencies
-- Inserted:
update  PH 
	set ph.internalupdate=1	
	from physresources PH join Inserted I on
	     ph.ID_PhysResource =I.ID_PhysResource
--	where ph.ID_PhysResource  in 
--		(select ID_PhysResource from inserted group by ID_PhysResource)

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'DOPO UPDT 1 TRG: ' + @p

/*
update  PH 
	set ph.acqfrequency=Vw_AcqFrequencies.MinVirtualAcqFrequency
	FROM (physresources ph INNER JOIN dbo.Vw_AcqFrequencies ON 
	     ph.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource) 
	     inner join Inserted I on 
	     ph.ID_PhysResource =I.ID_PhysResource
*/
update  PH 
	set acqfrequency=MinVirtualAcqFrequency
	FROM Vw_AcqFrequencies4UPDT ph  
	     inner join Inserted I on 
	     ph.ID_PhysResource =I.ID_PhysResource


--	where ph.ID_PhysResource  in 
--		(select ID_PhysResource from inserted group by ID_PhysResource)

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'DOPO UPDT 2 TRG: ' + @p

update  PH 
	set ph.internalupdate=0	
	from physresources PH join Inserted I on
	     ph.ID_PhysResource =I.ID_PhysResource
--	where ph.ID_PhysResource  in 
--		(select ID_PhysResource from inserted group by ID_PhysResource)

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'DOPO UPDT 3 PHRES/ACQFREQ TRG: ' + @p

--update in VirtualResources the StandByFlag field
declare @ID_VR as int
declare  CrsVRT Cursor for
	select ID_VirtualResource from inserted 
open CrsVRT
--for each item inserted
fetch next from CrsVRT into @ID_VR
while @@fetch_status = 0
begin
	exec updateVR @ID_VR
	fetch next from CrsVRT into @ID_VR
end
close CrsVRT
deallocate CrsVRT

set @CurTime=getdate()
set @p=convert( varchar,@CurTime,121)
print 'DOPO CHIUSURA CURSORE TRG: ' + @p

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on VirtualPhysResourceTable table.'
    goto errorHandler
 end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.VirtualPhysResourceTableUPDATE    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualPhysResourceTableUPDATE]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualPhysResourceTableUPDATE]
GO





CREATE          TRIGGER [VirtualPhysResourceTableUPDATE] ON [VirtualPhysResourceTable] 
FOR update
AS
BEGIN



print 'START: trigger VirtualPhysResourceTableUPDATE'


--print 'trigger VirtualPhysResourceTableUPDATE'

declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1
declare @ID_VRDel as int
declare @ID_VRIns as int
declare @errorNumber as int
declare @errorMsg as varchar(250)

--simulate a FK constraint
select @RowsRef = count(PR.ID_PhysResource)  from PhysResources PR where PR.ID_PhysResource in (select ID_PhysResource from inserted)
select @RowsIns = count(distinct ID_PhysResource) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             	@errorMsg = 'Data integrity violation between the table VirtualPhysResourceTable, field ID_PhysResource and the table PhysResources, field ID_PhysResource.'
	goto errorHandler
	
end

set @RowsRef = -1
set @RowsIns = -1

--simulate a FK constraint
select @RowsRef = count(VR.ID_VirtualResource)   from VirtualResources VR where VR.ID_VirtualResource in (select ID_VirtualResource from inserted)
select @RowsIns = count(distinct ID_VirtualResource) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             	@errorMsg = 'Data integrity violation between the table VirtualPhysResourceTable, field ID_VirtualResource and the table VirtualResources, field ID_VirualResource.'
	goto errorHandler
	
end

--update frequency on PhysResources
--
-- F. De Conti 13/06/2003
-- Riga seguente commentata e sostituita dalla successiva
-- Poi rivisto per limitare l'update alle sole righe coinvolte: prima il blocco per deleted,
-- poi per inserted
-- 10072003: rivisto, per l'introduzione della vista aggiornabile [Vw_AcqFrequencies4UPDT]
--exec [dbo].UpdateFrequency
--exec st_UpdateAllFrequencies
-- Deleted:
update  PH 
	set ph.internalupdate=1	
	from physresources PH join deleted D on
	     ph.ID_PhysResource =D.ID_PhysResource
--	where ph.ID_PhysResource in 
--		(select ID_PhysResource from deleted group by ID_PhysResource)

update  PH 
	set acqfrequency=MinVirtualAcqFrequency
	FROM Vw_AcqFrequencies4UPDT ph  
	     inner join deleted D on 
	     ph.ID_PhysResource =D.ID_PhysResource

/*
update  PH 
	set ph.acqfrequency=Vw_AcqFrequencies.MinVirtualAcqFrequency
	FROM (physresources ph INNER JOIN dbo.Vw_AcqFrequencies ON 
	     ph.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource) 
	     inner join deleted D on 
	     ph.ID_PhysResource =D.ID_PhysResource
--	where ph.ID_PhysResource in 
--		(select ID_PhysResource from deleted group by ID_PhysResource)
*/
update  PH 
	set ph.internalupdate=0	
	from physresources PH join deleted D on
	     ph.ID_PhysResource =D.ID_PhysResource
--	where ph.ID_PhysResource in 
--		(select ID_PhysResource from deleted group by ID_PhysResource)


-- Inserted:
update  PH 
	set ph.internalupdate=1	
	from physresources PH join Inserted I on
	     ph.ID_PhysResource =I.ID_PhysResource
	where ph.ID_PhysResource not in 
		(select ID_PhysResource from deleted group by ID_PhysResource)


update  PH 
	set acqfrequency=MinVirtualAcqFrequency
	FROM Vw_AcqFrequencies4UPDT ph  
	     inner join Inserted I on 
	     ph.ID_PhysResource =I.ID_PhysResource
	where ph.ID_PhysResource not in 
		(select ID_PhysResource from deleted group by ID_PhysResource)


/*
update  PH 
	set ph.acqfrequency=Vw_AcqFrequencies.MinVirtualAcqFrequency
	FROM (physresources ph INNER JOIN dbo.Vw_AcqFrequencies ON 
	     ph.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource) 
	     inner join Inserted I on 
	     ph.ID_PhysResource =I.ID_PhysResource
	where ph.ID_PhysResource not in 
		(select ID_PhysResource from deleted group by ID_PhysResource)
*/
update  PH 
	set ph.internalupdate=0	
	from physresources PH join Inserted I on
	     ph.ID_PhysResource =I.ID_PhysResource
	where ph.ID_PhysResource not in 

		(select ID_PhysResource from deleted group by ID_PhysResource)





-- De Conti, 17/06/2003
-- Il successivo non dovrebbe servire, perch se l'ID risorsa virtuale viene aggiornato,
-- questo dipende da un update sulla rispettiva tabella, e lo standbyflag non deve essere
-- toccato; diversamente, si innesca una ricorsione con il trigger di tabella


--update in VirtualResources the StandByFlag field
/*
declare  CrsVRTDel Cursor for select Id_VirtualResource from deleted 
declare  CrsVRTIns Cursor for select Id_VirtualResource from inserted
open CrsVRTDel
open CrsVRTIns 
--for each item Updated
fetch next from CrsVRTDel into @ID_VRDel
fetch next from CrsVRTIns into @ID_VRIns
while @@fetch_status = 0
begin

	if @ID_VRDel <> @ID_VRIns
	begin
		exec updateVR @ID_VRDel
		exec updateVR @ID_VRIns
	end
	else
		exec updateVR @ID_VRIns
	
	fetch next from CrsVRTDel into @ID_VRDel
	fetch next from CrsVRTIns into @ID_VRIns

end
close CrsVRTDel
deallocate CrsVRTDel
close CrsVRTIns
deallocate CrsVRTIns
*/
-- Fine modifica 17/06/2003

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on VirtualPhysResourceTable table.'
    goto errorHandler
 end


print 'END: trigger VirtualPhysResourceTableUPDATE'


  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

END



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.VirtualResourcesdelete    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualResourcesdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualResourcesdelete]
GO

CREATE Trigger VirtualResourcesdelete on dbo.VirtualResources 
for delete 
as

BEGIN
declare @errorNumber as int
declare @errormsg as varchar(255)

print 'Trigger VirtualResourcesdelete'
--delete fromVirtuallPhysResource Table
delete VirtualPhysResourceTable where ID_VirtualResource in (select del. ID_VirtualResource from deleted del)

--copy to History table
declare  CrsVirtResources cursor for select 
ID_VirtualResource, Name, Description, Notes, ResourceType, ValidateStartDate, Formula, EventAlarmCode, AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus
from deleted

declare @ID as int
declare @Name as varchar(50)
declare @Desc as varchar(50)
declare @Notes as varchar(255)
declare @RType as int
declare @Start as datetime
declare @Formula as varchar(50)
declare @EvAlCode as int 
declare @AcqF as int
declare @DataT as int 
declare @Format as int 
declare @MUnitID as int
declare @Min as float 
declare @Max as float
declare @Ref_IDPhysInstr as int
declare @Status as bit

open CrsVirtResources
fetch next from CrsVirtResources into 
@ID,@Name ,@Desc ,@Notes ,@RType ,@Start ,@Formula ,@EvAlCode ,@AcqF ,@DataT ,@Format ,@MUnitID ,@Min ,@Max ,@Ref_IDPhysInstr ,@Status 

WHILE @@FETCH_STATUS = 0
	begin	
	--update StandByFlag on VirtualInstruments table
	exec UpdateVI @Ref_IDPhysInstr
	--insert into history table
	insert Hist_VirtualResources(
	ID_VirtualResource, Name, Description, Notes, ResourceType, ValidateStartDate, ValidateEndDate, Formula, EventAlarmCode, AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus)
values (@ID,	          @Name ,  @Desc ,   @Notes ,  @RType ,      @Start , 		GETDATE(), 	@Formula ,@EvAlCode 	,@AcqF 		,@DataT   ,@Format   ,@MUnitID     ,@Min      ,@Max    ,@Ref_IDPhysInstr ,   @Status )
	fetch next from CrsVirtResources into 
	@ID,@Name ,@Desc ,@Notes ,@RType ,@Start ,@Formula ,@EvAlCode ,@AcqF ,@DataT ,@Format ,@MUnitID ,@Min ,@Max ,@Ref_IDPhysInstr ,@Status 
	end
CLOSE CrsVirtResources
DEALLOCATE CrsVirtResources

if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution on VirtualResources table.'
    goto errorHandler
end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Oggetto: trigger dbo.VirtualResourcesInsert    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualResourcesInsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualResourcesInsert]
GO




CREATE    TRIGGER [VirtualResourcesInsert] ON dbo.VirtualResources 
FOR INSERT 
AS

begin

print 'Trigger VirtualResourcesInsert'

declare @errorNumber as int
declare @errorMsg as varchar(250)
declare @RowsRef as int
set @RowsRef = -1
declare @RowsIns as int
set @RowsIns = -1

--check if there is a 0 value to be inserted
declare @RowsFr as int 
set @RowsFr = 0
select @RowsFr = count (id_VirtualResource ) from inserted where isnull(AcqFrequency,-1) = 0 
if @RowsFr > 0 
begin 
	select @errorNumber = 30004,
	@errorMsg = 'The 0 value is not allowed for the AcqFrequency field !' 
	goto errorHandler
end

--simulate a FK constraint
select @RowsRef = count(ID_VirtualInstrument)  from VirtualInstruments where ID_VirtualInstrument in (select Ref_IDVirtualInstr from inserted)
select @RowsIns = count(distinct Ref_IDVirtualInstr) from inserted

if @RowsIns > @RowsRef
begin 
	select @errorNumber = 30002,
             @errorMsg = 'Data integrity violation between the table VirtualInstruments, field ID_VirtualInstrument and the table VirtualResources, field Ref_IDVirtualInstr.'
	goto errorHandler
end






-- De Conti, 10072003
-- Modificato set di update usando join, unificando l'update di startdate e standbyflag,
-- e eliminando l'update di lastmodifieddate, che viene gi fatto dal trigger di update
--set the internalUpdate to allow the update without the update trigger to fire error message
--update VirtualResources set InternalUpdate = 1 
--	where id_VirtualResource in (select id_VirtualResource from inserted)
--set the start date
--update VirtualResources set validatestartdate = getdate() 
--	where id_VirtualResource in (select id_VirtualResource from inserted)

update VR
set 
	InternalUpdate = 1
from VirtualResources VR
	inner join inserted i on
	VR.id_VirtualResource=i.id_VirtualResource

/*
--set LastModifiedDate 
update dbo.VirtualResources set LastModifiedDate = GetDATE() 
	where id_VirtualResource in (select id_VirtualResource from inserted)
--set the StandByFlag to 2 <=> neutral status immediately after insert operation
update VirtualResources set StandByFlag = 2 
	where id_VirtualResource in (select id_VirtualResource from inserted)
*/

update VR
set 
	ValidateStartDate = GetDate(),
	StandByFlag = 2
from VirtualResources VR
	inner join inserted i on
	VR.id_VirtualResource=i.id_VirtualResource

--set the internalUpdate to neutral status
--update VirtualResources set InternalUpdate = 0 
--	where id_VirtualResource in (select id_VirtualResource from inserted)

update VR
set 
	InternalUpdate = 0
from VirtualResources VR
	inner join inserted i on
	VR.id_VirtualResource=i.id_VirtualResource


--update the mf StandByFlag
-- De Conti, 10072003
-- Modificata la seguente, perche' se pi risorse sono riferite al medesimo
-- strumento, la StProc UpdateVI viene rieseguita inutilmente
-- A seguito test, viene eliminato l'intero cursore, in quanto l'aggiornamento
-- appena eseguito su StandByFlag=2 lancia gi UpdateVI tramite il trigger di update
-- declare  CrsVirtResourcesInsert cursor for select Ref_IDVirtualInstr from inserted
/*
declare  CrsVirtResourcesInsert cursor for select distinct Ref_IDVirtualInstr from inserted
declare @Ref_IDPhysInstr as int
open CrsVirtResourcesInsert
fetch next from CrsVirtResourcesInsert into @Ref_IDPhysInstr

WHILE @@FETCH_STATUS = 0
	begin	
		exec UpdateVI @Ref_IDPhysInstr
		fetch next from CrsVirtResourcesInsert into @Ref_IDPhysInstr
	end
CLOSE CrsVirtResourcesInsert
DEALLOCATE CrsVirtResourcesInsert

*/

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during insert Trigger execution on VirtualResources table.'
    goto errorHandler
 end


  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction

end



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: trigger dbo.VirtualResourcesupdate    Data dello script: 10/07/2003 12.22.25 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualResourcesupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualResourcesupdate]
GO



CREATE                          Trigger VirtualResourcesupdate on dbo.VirtualResources 
for update 
as
BEGIN

if @@ROWCOUNT=0 
BEGIN
-- TRACE	print 'START/END: trigger VirtualResourcesupdate con ROWCOUNT=0'
	RETURN
END
print 'START: trigger VirtualResourcesupdate'

--Inserito 26/6/2003 F. De Conti
if update(internalupdate) 
BEGIN
-- TRACE	print 'END: trigger VirtualResourcesupdate su INTERNALUPDATE'
	return
END
--return


declare @TotROWCOUNT int
select @TotROWCOUNT=count(*) from inserted

declare @errorNumber int,@errorMsg varchar(255)

declare @Changed as int
declare @ChangedAcqFreq as int 
declare @StByChanged as int 
set @StByChanged = 0
set @ChangedAcqFreq = 0

declare @IDOld as int
declare @NameOld as varchar(50)
declare @DescOld as varchar(50)
declare @NotesOld as varchar(255)
declare @RTypeOld as int
declare @StartOld as datetime
declare @EndOld as datetime
declare @StdfOld as smallint
declare @FormulaOld as varchar(50)
declare @EvAlCodeOld as int 
declare @AcqFOld as int
declare @DataTOld as int 
declare @FormatOld as int 
declare @MUnitIDOld as int
declare @MinOld as float 
declare @MaxOld as float
declare @Ref_IDPhysInstrOld as int
declare @StatusOld as smallint
declare @Upd as smallint

declare @IDNew as int
declare @NameNew as varchar(50)
declare @DescNew as varchar(50)
declare @NotesNew as varchar(255)
declare @RTypeNew as int
declare @StartNew as datetime
declare @EndNew as datetime
declare @StdfNew as smallint
declare @FormulaNew as varchar(50)
declare @EvAlCodeNew as int 
declare @AcqFNew as int
declare @DataTNew as int 
declare @FormatNew as int 
declare @MUnitIDNew as int
declare @MinNew as float 
declare @MaxNew as float
declare @Ref_IDPhysInstrNew as int
declare @StatusNew as smallint

declare CrsOldVR cursor for select ID_VirtualResource, Name, Description, Notes, ResourceType, ValidateStartDate, LastModifiedDate, StandByFlag, Formula, EventAlarmCode, 
AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus, InternalUpdate from deleted
declare CrsNewVR cursor for select ID_VirtualResource,  Name, Description,Notes, ResourceType, ValidateStartDate, LastModifiedDate, StandByFlag, Formula, EventAlarmCode, 
AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus from inserted

open CrsOldVR
open CrsNewVR
fetch next from CrsOldVR      into @IDOld , @NameOld, @DescOld, @NotesOld,  @RTypeOld , @StartOld , @EndOld, @StdfOld, @FormulaOld , @EvAlCodeOld , 
@AcqFOld , @DataTOld , @FormatOld , @MUnitIDOld , @MinOld , @MaxOld , @Ref_IDPhysInstrOld, @StatusOld, @Upd
fetch next from CrsNewVR  into @IDNew, @NameNew, @DescNew, @NotesNew,  @RTypeNew , @StartNew , @EndNew, @StdfNew, @FormulaNew , @EvAlCodeNew , 
@AcqFNew , @DataTNew , @FormatNew , @MUnitIDNew , @MinNew , @MaxNew , @Ref_IDPhysInstrNew, @StatusNew

-- De Conti 30/06/2003 
-- ATTENZIONE: la var di tipo char tiene 1 solo carattere)

declare @cmp as char
set @cmp = 'X#_#Y'


-- De Conti 30/06/2003 
-- Anticipo qui la seguente dichiarazione che era all'interno del ciclo while del cursore
declare @CrtDate as datetime

declare @datcmp as datetime
set @datcmp = convert(datetime, '29/07/1969', 103)

--print'trigger VirtualResourcesupdate'
--print @cmp
WHILE @@FETCH_STATUS = 0
begin
	set @Changed = 0
	set @StByChanged = 0
	set @ChangedAcqFreq = 0	
	if isnull(@StartOld, @datcmp) <> isnull(@StartNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field ValidateStartDate cannot be modified by user !' 
			goto errorHandler
		end
	end

	if isnull(@EndOld, @datcmp) <> isnull(@EndNew,@datcmp)
	begin 
		if isnull(@Upd, 0) = 0
		--if the update is done from a trigger than skip it; if it is done by the user than spit the message
		begin
			select @errorNumber = 30004,
	             		@errorMsg = 'The field LastModifiedDate cannot be modified by user !' 
			goto errorHandler
		end
	end

	--if isnull(@StdfOld, -1) <> isnull(@StdfNew, -1)
	--begin 
	--	if isnull(@Upd, 0) = 0
	--	--if the update is done from a trigger than skip it; if it is done by the user than spit the message
	--	begin
	--		select @errorNumber = 30004,

	 --            		@errorMsg = 'The field StandbyFlag cannot be modified by user !' 
	--		goto errorHandler
	--	end
	--end

	if isnull(@AcqFOld ,-1)  <> isnull(@AcqFNew,  -1)
		begin
			--the 0 value is not allowed for the AcqFrequency filed
			if isnull(@AcqFNew,-1) <= 0
			begin 
				select @errorNumber = 30004,
	             			--@errorMsg = 'The 0 value is not allowed for the AcqFrequency field !' 
	             			@errorMsg = 'The value for the AcqFrequency field must be greater than zero!' 
				goto errorHandler
			end  			
	        set @ChangedAcqFreq = 1
	
		-- De Conti, 30/06/2003
		-- Commento la seguente in modo che non copi nello storico se  cambiata solo questa
		--		set @Changed = 1
		end

-- De Conti, 30/06/2003
-- Le seguenti impostano solo la var @Changed, quindi posso saltare dopo che una sola  verificata:
-- aggiunto il goto, che non  bello, ma funziona senza alterare la struttura del codice esistente

	if isnull(@StdfOld, 0) <> isnull(@StdfNew, 0)
	begin 
		--if @StdfNew <> 2 -- 2 is for neutral status
		set @StByChanged = 1
	end
--if one of these fields was changed, the trigger will fire the stuff 
	if isnull(@IDOld ,-1)<> isnull(@IDNew ,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@NotesOld,@cmp) <> isnull(@NotesNew, @cmp)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@RTypeOld  ,-1) <> isnull(@RTypeNew ,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@FormulaOld ,-1)  <> isnull(@FormulaNew ,-1) 
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@EvAlCodeOld ,-1)  <> isnull(@EvAlCodeNew ,-1) 
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@DataTOld ,-1) <> isnull(@DataTNew ,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@FormatOld,-1) <> isnull(@FormatNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@MUnitIDOld,-1) <> isnull(@MUnitIDNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@MinOld,-1) <> isnull(@MinNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@MaxOld,-1) <> isnull(@MaxNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@Ref_IDPhysInstrOld,-1) <> isnull(@Ref_IDPhysInstrNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END
	if isnull(@StatusOld,-1) <> isnull(@StatusNew,-1)
		BEGIN
			set @Changed = 1
			goto HasChanged
		END


HasChanged:
	--the trigger fires if one of the above mentioned fileds are changed
	if (@Changed = 1) or (@ChangedAcqFreq=1)
		begin
			/******************* simulate the FK ********************************/
	
			if update(Ref_IDVirtualInstr)	
				begin
					declare @Rows as int
					--check the reference in VirtualInstruments table
					select @Rows = count(VI.ID_VirtualInstrument) from VirtualInstruments VI where VI.ID_VirtualInstrument in (@Ref_IDPhysInstrNew)
					if @Rows = 0
					begin
						select @errorNumber = 30002,
			             			@errorMsg = 'Data integrity violation between the table VirtualResources, field Ref_IDVirtualInstr and the table VirtualInstruments, field ID_VirtualInstrument.'
						goto errorHandler
					end
				end

			set @CrtDate = GETDATE()



			--this is useless because the ID is autonumber and so , never will be updated; 
			--it will be useful if the table structure will be changed in future
			if update(ID_VirtualResource)
				begin	
					--
					-- F. De Conti (13/06/2003)
					-- ATTENZIONE! la seguente istruzione fa scattare il trigger di update sulla relativa tabella,
					-- e quindi la stProc di aggiornamento frequenze; per il momento lascio cos
					-- perch  improbabile un update sull'ID e sulla frequenza insieme, e ci sono punti pi urgenti
					-- una soluzione in linea con il resto sarebbe quella di introdurre una colonna InternalUpdate
					-- anche su VirtualPhysResourceTable, ma al momento non sono previste modifiche strutturali sulle
					-- tabelle del DB
					--
					update VirtualPhysResourceTable set VirtualPhysResourceTable.ID_VirtualResource = @IDNew from VirtualPhysResourceTable
							                       where VirtualPhysResourceTable.ID_VirtualResource = @IDOld
					update ContextRelations set ContextRelations.ID_VirtualResource = @IDNew from ContextRelations
							                       where ContextRelations.ID_VirtualResource = @IDOld 
					update ContextRelations set ContextRelations.Ctx_VirtResID = @IDNew from ContextRelations
							                       where ContextRelations.Ctx_VirtResID = @IDOld
				end
			/*******************finish  simulate the FK********************************/
		
	
			--#1 update in the current table the new ValidateStartDate value
			-- De Conti, 30/06/2003
			-- La seguente viene spostata insieme alla copia nello storico, poco sotto
			-- update VirtualResources set ValidateStartDate =@CrtDate where VirtualResources.ID_VirtualResource = @IDNew			
	
			--#2 the records will be copied into the history table
	                -- evito la copia nell History table se  cambiata la freq Acq o il name
--			if @ChangedAcqFreq = 0
			if @Changed=1
	  			begin
					insert Hist_VirtualResources(
				 			ID_VirtualResource, Name, Description,  Notes,        ResourceType,   ValidateStartDate, ValidateEndDate, Formula,         EventAlarmCode, AcqFrequency, DataTypeID, FormatID,       MeasureUnitID, MinValue, MaxValue,   Ref_IDVirtualInstr,        ModifiedStatus)
				 			values ( @IDOld ,          @NameOld, @DescOld, @NotesOld,  @RTypeOld ,   @StartOld ,            @CrtDate,          @FormulaOld , @EvAlCodeOld , @AcqFOld ,     @DataTOld , @FormatOld , @MUnitIDOld , @MinOld , @MaxOld , @Ref_IDPhysInstrOld, @StatusOld)
					update VirtualResources set ValidateStartDate =@CrtDate where VirtualResources.ID_VirtualResource = @IDNew			
				end
		
			--#3 update the Frequency fields in the correspondent Physical resources
			if @ChangedAcqFreq = 1 and not update(ID_VirtualResource) 
	            BEGIN
					IF @TotROWCOUNT=1
					BEGIN	
	 			             IF EXISTS(SELECT name FROM sysobjects WHERE name = 'st_UpdateFrequencyByVirtualRes' AND type = 'P')
				    	          exec [dbo].st_UpdateFrequencyByVirtualRes @IDNew
					END
	            END
			
			--#4 update StandByFlag on VirtualInstruments table		
			--  De Conti, 30/06/2003
			-- La seguente spostata poco sotto, per evitare di lanciare due volte UpdateVI
			-- (anche se la probabilit  bassa)
			/*
			if update(Ref_IDVirtualInstr)
				exec UpdateVI @Ref_IDPhysInstrNew		
			*/
		end /*@Changed=1 */

	-- handle the case when the StandBy Flag was updated
	if (@StByChanged = 1) or 	(isnull(@Ref_IDPhysInstrOld,-1) <> isnull(@Ref_IDPhysInstrNew,-1))
		exec UpdateVI @Ref_IDPhysInstrNew

	--update LastModifiedDate at each update operation on the table no metter the field's type
	-- Modificata F. De Conti 16/06/2003
	--update dbo.VirtualResources set LastModifiedDate = GetDATE() 
	--	where id_VirtualResource in (select id_VirtualResource from inserted)
	update VirtualResources set LastModifiedDate = GetDATE() 
		where id_VirtualResource =@IDNew



	fetch next from CrsOldVR      into @IDOld , @NameOld, @DescOld, @NotesOld,  @RTypeOld , @StartOld , @EndOld, @StdfOld, @FormulaOld , @EvAlCodeOld , 
	@AcqFOld , @DataTOld , @FormatOld , @MUnitIDOld , @MinOld , @MaxOld , @Ref_IDPhysInstrOld, @StatusOld, @Upd
	fetch next from CrsNewVR  into @IDNew, @NameNew, @DescNew, @NotesNew,  @RTypeNew , @StartNew , @EndNew, @StdfNew, @FormulaNew , @EvAlCodeNew , 
	@AcqFNew , @DataTNew , @FormatNew , @MUnitIDNew , @MinNew , @MaxNew , @Ref_IDPhysInstrNew, @StatusNew

end

if (@TotROWCOUNT>1) and (update(AcqFrequency)) and not update(ID_VirtualResource)
BEGIN

-- Da sviluppare sui successivi
-- Se non c' update su ID, i valori ID per inserted e deleted coincidono, quindi  sufficiente considerarne uno dei due

update     PH
	set ph.internalupdate=1	
FROM    PhysResources PH 
        where ph.ID_PhysResource in
		(SELECT  VPhRT.ID_PhysResource
                  FROM    VirtualPhysResourceTable VPhRT INNER JOIN
                          deleted D ON VPhRT.ID_VirtualResource = D.ID_VirtualResource
                  GROUP BY VPhRT.ID_PhysResource)

update  PH 
	set ph.acqfrequency=Vw_AcqFrequencies.MinVirtualAcqFrequency
	FROM (physresources ph INNER JOIN dbo.Vw_AcqFrequencies ON 
	     ph.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource) 
        where ph.ID_PhysResource in
		(SELECT  VPhRT.ID_PhysResource
                  FROM    VirtualPhysResourceTable VPhRT INNER JOIN
                          deleted D ON VPhRT.ID_VirtualResource = D.ID_VirtualResource
                  GROUP BY VPhRT.ID_PhysResource)

update     PH
	set ph.internalupdate=0	
FROM    PhysResources PH 
        where ph.ID_PhysResource in
		(SELECT  VPhRT.ID_PhysResource
                  FROM    VirtualPhysResourceTable VPhRT INNER JOIN
                          deleted D ON VPhRT.ID_VirtualResource = D.ID_VirtualResource
                  GROUP BY VPhRT.ID_PhysResource)






--	exec st_updateallfrequencies
END

if @@error <> 0
begin
   select @errorNumber = 30003,
             @errorMsg = 'Error during update Trigger execution on VirtualResources table.'
    goto errorHandler
end

close CrsOldVR
close CrsNewVR
deallocate CrsOldVR
deallocate CrsNewVR


-- TRACE print 'END: trigger VirtualResourcesupdate'

return

errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
close CrsOldVR
close CrsNewVR
deallocate CrsOldVR
deallocate CrsNewVR
END


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



/****** Oggetto: vista dbo.Vw_AcqFrequencies    Data dello script: 10/07/2003 12.22.22 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_AcqFrequencies]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_AcqFrequencies]
GO

CREATE VIEW dbo.Vw_AcqFrequencies
AS
SELECT     TOP 100 PERCENT dbo.PhysResources.ID_PhysResource, dbo.PhysResources.Name, dbo.PhysResources.AcqFrequency, 
                      dbo.VirtualResources.ID_VirtualResource, MIN(dbo.VirtualResources.AcqFrequency) AS MinVirtualAcqFrequency
FROM         dbo.PhysResources INNER JOIN
                      dbo.VirtualPhysResourceTable VirtualPhysResourceTable_1 ON 
                      dbo.PhysResources.ID_PhysResource = VirtualPhysResourceTable_1.ID_PhysResource INNER JOIN
                      dbo.VirtualResources ON VirtualPhysResourceTable_1.ID_VirtualResource = dbo.VirtualResources.ID_VirtualResource
GROUP BY dbo.PhysResources.ID_PhysResource, dbo.PhysResources.Name, dbo.VirtualResources.ID_VirtualResource, dbo.PhysResources.AcqFrequency

GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


/****** Oggetto: vista dbo.Vw_AcqFrequencies4UPDT    Data dello script: 10/07/2003 12.22.22 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_AcqFrequencies4UPDT]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_AcqFrequencies4UPDT]
GO

CREATE VIEW dbo.Vw_AcqFrequencies4UPDT
AS
SELECT dbo.PhysResources.ID_PhysResource, dbo.PhysResources.AcqFrequency, dbo.Vw_AcqFrequencies.ID_PhysResource AS ID, 
dbo.Vw_AcqFrequencies.MinVirtualAcqFrequency
FROM   dbo.PhysResources INNER JOIN
dbo.Vw_AcqFrequencies ON dbo.PhysResources.ID_PhysResource = dbo.Vw_AcqFrequencies.ID_PhysResource
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

-- Version Upgrade (user must only modify version number) 
--
UPDATE  GENERICSETTINGS SET SETVALUE='01.00.03' WHERE NAME='DB_VERSION'

-------------------------------- ACQUIRED DB ---------------------------
----------------------------------------------------------------------
USE _AcquiredDB_x


-- DeviceStatus
--
ALTER TABLE [dbo].[DeviceStatus] 
ADD CountryCode int NULL 
GO

DELETE FROM DeviceStatus
GO

INSERT INTO DeviceStatus (Code,Description,CountryCode)
SELECT Code,Description,CountryCode FROM _TemplateAcquiredDB_x.dbo.DeviceStatus

GO

-- end custom code for upgrade


COMMIT;

GO