------------------------------------------------------------------
------------------------------------------------------------------
-- Author:     	 A.Losso
-- Date:  	 11/09/2003
-- Dependencies: to_01.00.03.sql
-- Notes: Script no compatible with OLEDB if GO is present to
--        separate batch. GO must be placed  before CREATE statements.
--
-- Update to version 1.1.0 
--
------------------------------------------------------------------
------------------------------------------------------------------


BEGIN TRANSACTION

-- place customom SQL And DDL for upgrade here (place GO before CREATE statements) 

USE _ConfigDB_x


-----------------------------
-- view VW_VIRTINSTR_ALMSBASE

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_VirtInstr_AlmsBase]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_VirtInstr_AlmsBase]
GO

CREATE  VIEW dbo.Vw_VirtInstr_AlmsBase
AS
SELECT  VI.ID_VirtualInstrument, 
	VI.Description, 
	VI.Name, 
	VR.ResourceType, 
	VR.EventAlarmCode
FROM    dbo.VirtualResources VR INNER JOIN
        dbo.VirtualInstruments  VI ON VR.Ref_IDVirtualInstr = VI.ID_VirtualInstrument
WHERE     (VR.ResourceType = 4)
GO

-----------------------------
-- Table AutomaticReport

Alter table AutomaticReport alter column ReportName varchar(50)
Alter table AutomaticReport alter column LastPrintTime varchar(25)
Alter table AutomaticReport alter column ReportTitle varchar(50)
Alter table AutomaticReport alter column NextPrintTime varchar(25)
Alter table AutomaticReport alter column NextPrintTime1 varchar(25)
Alter table AutomaticReport alter column NextPrintTime2 varchar(25)
Alter table AutomaticReport alter column NextPrintTime3 varchar(25)
Alter table AutomaticReport alter column NextPrintTime0 varchar(25)
GO

-- Version Upgrade (user must only modify version number) 
--
UPDATE  GENERICSETTINGS SET SETVALUE='01.01.00' WHERE NAME='DB_VERSION'
GO


USE _AcquiredDB_x

-------------------------------
-- table ALARMCLASSESCONNECTION

-- default assegnato per i dati esistenti
alter table AlarmClassesConnection add Ref_PlantID int not null default (1)
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[IX_AlarmPlantID]') and OBJECTPROPERTY(id, N'IsIndex') = 1)
drop index [dbo].[IX_AlarmPlantID]
GO

CREATE  INDEX [IX_AlarmPlantID] ON [dbo].[AlarmClassesConnection]([Ref_PlantID]) ON [PRIMARY]
GO
-----------------------------
-- table ALARMCLASSES

-- default assegnato per i dati esistenti
alter table AlarmClasses add TimeToLive int not null default (10)
GO


--------------------------------------
--stored Procedure ST_INSTRCONNBYCLASS

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_InstrConnByClass]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_InstrConnByClass]
GO

CREATE PROCEDURE [st_InstrConnByClass] 
@ClassID integer
AS
SELECT     ref_PlantID,Ref_IdVIClass
FROM         dbo.AlarmClassesConnection
where ref_AlarmClassID=@Classid
GROUP BY ref_PlantID,Ref_IdVIClass

GO


-- Inserimento PlantID in Genericsettings (plantName  gi presente
-- Tabella Acceduta dalla vista succesiva
Insert into GenericSettings ([Name],SetValue) values ('PlantID',1);


------------------------------------------
--stored Procedure ST_SYSUPDATEVIEWBYDBNAME

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_SysUpdateViewsByDBNAmes]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_SysUpdateViewsByDBNAmes]
GO

CREATE    PROCEDURE [st_SysUpdateViewsByDBNAmes] 
@AcqDBName varchar(100),
@CfgDBName varchar(100)


AS

declare @MyCommand varchar(4000)
declare @MyCommand1 varchar(4000)
declare @PlantName varchar(50)

BEGIN

		if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_AlmCfgFromPlants]') and OBJECTPROPERTY(id, N'IsView') = 1)
		drop view [dbo].[Vw_AlmCfgFromPlants]
END

BEGIN
	if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetPlantName]') and xtype in (N'FN', N'IF', N'TF'))
	BEGIN	
		set @MyCommand='drop function [dbo].[GetPlantName]'
		exec (@MyCommand)
	END

	set @MyCommand='CREATE  FUNCTION GetPlantName () ' +
	               	'RETURNS varchar (50) ' +
					'AS  ' +
					'BEGIN ' +
						'declare @PlantName varchar(50) '+
						'select @PlantName=setvalue 	FROM ' + @CfgDBName + '.dbo.GenericSettings ' +
						'WHERE [Name]=''PlantName'' ' +
						'set @PlantName=isnull(@PlantName,''CURRENT PLANT'') ' +
					 	'return (@PlantName) ' +
					'END'

	exec (@MyCommand)
END


BEGIN
	set @PlantName='CURRENT PLANT'
	if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetPlantName]') and xtype in (N'FN', N'IF', N'TF'))
			set @PlantName=dbo.GetPlantName()

	set  @MyCommand=' create view Vw_AlmCfgFromPlants ' + 
			'as ' +
			'SELECT 1 as PlantID,''' + @PlantName + ''' as PlantName, cfgbase.* ' +
			'FROM  ' + @CfgDBName +'.dbo.Vw_VirtInstr_AlmsBase as CfgBASE '	

	--print @mycommand	
	exec (@MyCommand)

END


BEGIN

	if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_DigitalOutputs]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[Vw_DigitalOutputs]
end

begin
	set  @MyCommand='Create view Vw_DigitalOutputs ' + 
			'as ' +
			'select * from 	' + @CfgDBName + '.dbo.Vw_DigitalOutputs'	
	exec (@MyCommand)
END

GO

-- esecuzione della stored procedure

EXEC [_AcquiredDB_x].[dbo].[st_SysUpdateViewsByDBNAmes] '_AcquiredDB_x', '_ConfigDB_x'

-----------------------------
--view VW_VIRTINSTR_ALMS
--view VW_VIRTINSTR_ALMS_GRP


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_VirtInstr_Alms_GRP]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_VirtInstr_Alms_GRP]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_VirtInstr_Alms]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_VirtInstr_Alms]
GO

Create view Vw_VirtInstr_Alms as SELECT  _configDB_X.dbo.VirtualInstruments.ID_VirtualInstrument, _configDB_X.dbo.VirtualInstruments.Description, _configDB_X.dbo.VirtualInstruments.Name, _configDB_X.dbo.VirtualResources.ResourceType, _configDB_X.dbo.VirtualResources.EventAlarmCode, _acquiredDB_X.dbo.AlarmsDictionary.Description AS AlmDesc, _acquiredDB_X.dbo.AlarmsDictionary.CountryCode FROM   _configDB_X.dbo.VirtualResources INNER JOIN _configDB_X.dbo.VirtualInstruments ON _configDB_X.dbo.VirtualResources.REF_IDVirtualInstr = _configDB_X.dbo.VirtualInstruments.ID_VirtualInstrument INNER JOIN _acquiredDB_X.dbo.AlarmsDictionary ON _configDB_X.dbo.VirtualResources.EventAlarmCode = _acquiredDB_X.dbo.AlarmsDictionary.AlarmCode WHERE   (_configDB_X.dbo.VirtualResources.ResourceType = 4) 
GO

CREATE VIEW dbo.Vw_VirtInstr_Alms_GRP
AS
SELECT     ID_VirtualInstrument,  Description, Name
FROM         dbo.Vw_VirtInstr_Alms
GROUP BY ID_VirtualInstrument,  Description, Name

GO

	

-- end custom code for upgrade (place GO before CREATE statements) 

COMMIT;

GO