------------------------------------------------------------------
------------------------------------------------------------------
-- Author:
-- Date:
-- Notes: Script non compatible with OLEDB if GO is present to
--        separate batch. GO must be placed  before CREATE statements.
--
--
------------------------------------------------------------------
------------------------------------------------------------------


BEGIN TRANSACTION

-- place customom SQL And DDL for upgrade here (place GO before CREATE statements) 

USE _ConfigDB_x

-- Disabilito le tabelle dalle pubblicazioni prima di modificarne la struttura
--

DECLARE @ConfigCurrentPublication varchar(50)
SET @ConfigCurrentPublication= 'Config_ForLink'

execute sp_dropmergearticle  @publication =@ConfigCurrentPublication,@article ='VirtualResources'
execute sp_dropmergearticle  @publication =@ConfigCurrentPublication,@article ='Hist_VirtualResources'
    


-- default assegnato per i dati esistenti
alter table VirtualResources add AlmDelayIn int not null default (0)
alter table VirtualResources add AlmDelayOut int not null default (0)

alter table Hist_VirtualResources add AlmDelayIn int
alter table Hist_VirtualResources add AlmDelayOut int

GO

-- Aggiornamento trigger di delete della tabella VirtualResources 
--
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualResourcesdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[VirtualResourcesdelete]
GO

CREATE Trigger VirtualResourcesdelete on dbo.VirtualResources 
for delete 
as

BEGIN
declare @errorNumber as int
declare @errormsg as varchar(255)

print 'Trigger VirtualResourcesdelete'
--delete fromVirtuallPhysResource Table
delete VirtualPhysResourceTable where ID_VirtualResource in (select del. ID_VirtualResource from deleted del)

--copy to History table
declare  CrsVirtResources cursor for select 
ID_VirtualResource, Name, Description, Notes, ResourceType, ValidateStartDate, Formula, EventAlarmCode, AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus,AlmDelayIn,AlmDelayOut
from deleted

declare @ID as int
declare @Name as varchar(50)
declare @Desc as varchar(50)
declare @Notes as varchar(255)
declare @RType as int
declare @Start as datetime
declare @Formula as varchar(50)
declare @EvAlCode as int 
declare @AcqF as int
declare @DataT as int 
declare @Format as int 
declare @MUnitID as int
declare @Min as float 
declare @Max as float
declare @Ref_IDPhysInstr as int
declare @Status as bit
declare @AlmDelayIn as int
declare @AlmDelayOut as int

open CrsVirtResources
fetch next from CrsVirtResources into 
@ID,@Name ,@Desc ,@Notes ,@RType ,@Start ,@Formula ,@EvAlCode ,@AcqF ,@DataT ,@Format ,@MUnitID ,@Min ,@Max ,@Ref_IDPhysInstr ,@Status,@AlmDelayIn,@AlmDelayOut

WHILE @@FETCH_STATUS = 0
	begin	
	--update StandByFlag on VirtualInstruments table
	exec UpdateVI @Ref_IDPhysInstr
	--insert into history table
	insert Hist_VirtualResources(
	ID_VirtualResource, Name, Description, Notes, ResourceType, ValidateStartDate, ValidateEndDate, Formula, EventAlarmCode, AcqFrequency, DataTypeID, FormatID, MeasureUnitID, MinValue, MaxValue, Ref_IDVirtualInstr, ModifiedStatus,AlmDelayIn,AlmDelayOut)
values (@ID,	          @Name ,  @Desc ,   @Notes ,  @RType ,      @Start , 		GETDATE(), 	@Formula ,@EvAlCode 	,@AcqF 		,@DataT   ,@Format   ,@MUnitID     ,@Min      ,@Max    ,@Ref_IDPhysInstr ,   @Status, @AlmDelayIn, @AlmDelayOut )
	fetch next from CrsVirtResources into 
	@ID,@Name ,@Desc ,@Notes ,@RType ,@Start ,@Formula ,@EvAlCode ,@AcqF ,@DataT ,@Format ,@MUnitID ,@Min ,@Max ,@Ref_IDPhysInstr ,@Status 
	end
CLOSE CrsVirtResources
DEALLOCATE CrsVirtResources

if @@error <> 0
begin
   select @errorNumber = 30004,
             @errorMsg = 'Error during delete Trigger execution on VirtualResources table.'
    goto errorHandler
end

  return
errorHandler:
  raiserror @errorNumber @errorMsg
  rollback transaction
END

GO


-- Re-inserisco le tabelle nella pubblicazione
--

DECLARE @ConfigCurrentPublication varchar(50)
SET @ConfigCurrentPublication= 'Config_ForLink'

execute sp_addmergearticle @publication =@ConfigCurrentPublication,@article ='VirtualResources',@source_object ='VirtualResources',@pre_creation_cmd='Delete',@schema_option = 0x01
execute sp_addmergearticle @publication =@ConfigCurrentPublication,@article ='Hist_VirtualResources',@source_object ='Hist_VirtualResources',@pre_creation_cmd='Delete',@schema_option = 0x01

GO

--- Version Upgrade (user must only modify version number) 
--
UPDATE  GENERICSETTINGS SET SETVALUE='01.01.01' WHERE NAME='DB_VERSION'
GO



USE _AcquiredDB_x


-- end custom code for upgrade (place GO before CREATE statements) 


COMMIT;

GO