------------------------------------------------------------------------------------------------------------
------------------------------- Step 1/2: Run Before a New Network Scan 
-------------------------------           after an upgrade to rel of Televis Net 1.2.0
------------------------------------------------------------------------------------------------------------

USE _ConfigDB_x

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualInstruments_OLD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[VirtualInstruments_OLD]
GO 
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VRNameChanged]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[VRNameChanged]
GO 
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VRAlmDelayChanged]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[VRAlmDelayChanged]
GO 

CREATE TABLE [VirtualInstruments_OLD] (
	[ID_VirtualInstrument] [int] NOT NULL ,
	[Name] [varchar] (50) NULL ,
	[Description] [varchar] (50) NULL ,
	[ValidateStartDate] [datetime] NULL ,
	[LastModifiedDate] [datetime] NULL ,
	[StandbyFlag] [smallint] NULL ,
	[Notes] [varchar] (255) NULL ,
	[RegSpeedHist] [smallint] NULL ,
	[RegSpeedFlash] [smallint] NULL ,
	[InstrumentClassCode] [int] NOT NULL ,
	[InternalUpdate] [smallint] NULL ,
	[rowguid]  uniqueidentifier ROWGUIDCOL  NULL
) ON [PRIMARY]
GO

CREATE TABLE [VRNameChanged] (
	[VIId] [int] NOT NULL ,
	[ADDRESS] [varchar] (5)  ,
	[VIName] [varchar] (50)  ,
	[VRNAme] [varchar] (50)  ,
	[PRName] [varchar] (50)  ,
	[ResourceType] [int] NULL ,
	[EventAlarmCode] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [VRAlmDelayChanged] (
	[VIId] [int] NOT NULL ,
	[ADDRESS] [varchar] (5) ,
	[VIName] [varchar] (50) ,
	[VRName] [varchar] (50) ,
	[AlmDelayIn] [int] NULL ,
	[AlmDelayOut] [int] NULL ,
	[ResourceType] [int] NULL ,
	[EventAlarmCode] [int] NULL 
) ON [PRIMARY]
GO

DECLARE @PCINTERFACE_NUMBER varchar(10)
set @PCINTERFACE_NUMBER = '148'+':'

-- Instrument name Saving
--
insert into virtualinstruments_OLD select * from virtualinstruments


-- Virtual Resource name saving
--
insert into VRNameChanged
select VI.ID_VirtualInstrument,SUBSTRING(REPLACE(VI.Description,@PCINTERFACE_NUMBER,''),1,5) ADDRESS,VI.Name VIName,VR.Name VRNAme,PR.Name PRName,VR.ResourceType,VR.EventAlarmCode
from dbo.VirtualInstruments VI,dbo.VirtualResources VR,
dbo.PhysResources PR, dbo.VirtualPhysResourceTable VPV
where 
VI.ID_VirtualInstrument=VR.Ref_IDVirtualInstr AND
VR.ID_VirtualResource=VPV.ID_VirtualResource AND
PR.ID_PhysResource=VPV.ID_PhysResource AND
LTRIM(RTRIM(VR.Name)) <> LTRIM(RTRIM(PR.Name))

-- Alarm Delay Saving
--
insert into VRAlmDelayChanged
select VR.Ref_IDVirtualInstr VIId,SUBSTRING(REPLACE(VI.Description,@PCINTERFACE_NUMBER,''),1,5) ADDRESS,VI.Name,VR.Name,VR.AlmDelayIn,VR.AlmDelayOut,
	VR.ResourceType,VR.EventAlarmCode
from VirtualResources VR,VirtualInstruments VI
where VI.ID_VirtualInstrument=Ref_IDVirtualInstr
AND AlmDelayIn<> 0 or AlmDelayOut<> 0

GO